/*--------------------------------------------------------------------------
    woddity - WebOddity, Web Server                              
    Copyright (C) 2001 - Robin Burgener, robinb@20q.net                     
                                                                            
    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by    
    the Free Software Foundation; either version 2 of the License, or       
    (at your option) any later version.                                     
                                                                            
    This program is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           
    GNU General Public License for more details.                            
                                                                            
    You should have received a copy of the GNU General Public License       
    along with this program; if not, write to the Free Software             
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               
                                                                            
--------------------------------------------------------------------------*/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <stddef.h>
#include <signal.h>
#include <time.h>
#include <sys/timeb.h>
#include <stdarg.h>

#include "woddity.h"

static char	MyURL[256];

#define	ImageMod	16
#define	ColourMod	7
#define	BGColourMod	7
#define	TotalMod	(ImageMod * ColourMod * BGColourMod)

#define	ColourDiv	(ImageMod)
#define	BGColourDiv	(ColourDiv*ColourMod)


static ulong_t Colours[] = {
	0xFF0000,		// red
	0xFF8000,		// orange
	0xFFFF00,		// yellow
	0x00FF00,		// green
	0x0000FF,		// blue
	0xCC00FF,		// purple
	0xFFFFFF,
	0xFFFFFF,
	0xFFFFFF,
	0xFFFFFF,
};

static ulong_t BGColours[] = {
	0x000000,		// black
	0xAA0010,		// red
	0x008000,		// green
	0x0000AA,		// blue
	0x8000AA,		// purple
	0xAA6600,		// brown
	0x808080,
	0x808080,
	0x808080,
	0x808080,
};

static char Image1[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF3, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0xF0, 0xF0, 0xF0, 0x30, 0x64, 0x98, 0xE4, 0xE4, 0xE4, 0x30,
	0x64, 0x64, 0xC8, 0xC8, 0xC8, 0x98, 0x98, 0xCC, 0xCC, 0xCC, 0xCC, 0x64, 0x98, 0x98, 0xB8, 0xB8, 0xB8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2C, 0x00, 0x00,
	0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x04, 0xE7, 0x50, 0xC8, 0x49, 0xAB, 0xBD, 0x38, 0xEB, 0xCD, 0xBB, 0xFF, 0x60, 0x28, 0x8E, 0x64, 0x69, 0x9E, 0x68, 0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70,
	0x2C, 0xCF, 0x74, 0x6D, 0xDF, 0x78, 0xAE, 0xEF, 0xBC, 0x60, 0x18, 0x3D, 0x0E, 0x01, 0x91, 0x28, 0x0C, 0x02, 0x81, 0x41, 0x21, 0x81, 0x20, 0x04, 0x29, 0x84, 0x03, 0x72, 0x4A, 0x9D, 0x1E, 0x9C,
	0x41, 0xC4, 0xB1, 0xCA, 0x45, 0x0E, 0x10, 0x3C, 0x83, 0xB4, 0x4B, 0x46, 0x1E, 0x80, 0x38, 0x43, 0xA1, 0xCC, 0x0E, 0x14, 0xD0, 0xB6, 0x75, 0x9B, 0x5D, 0xB8, 0x2D, 0xE6, 0xF3, 0x45, 0x0D, 0x81,
	0xC7, 0x83, 0x65, 0x04, 0x5B, 0x7D, 0x6C, 0x03, 0x58, 0x30, 0x63, 0x83, 0x6D, 0x07, 0x31, 0x04, 0x89, 0x7D, 0x86, 0x2D, 0x0A, 0x8E, 0x78, 0x0A, 0x30, 0x09, 0x93, 0x73, 0x09, 0x30, 0x72, 0x98,
	0x65, 0x75, 0x2F, 0x82, 0x9D, 0x5D, 0x03, 0x2F, 0x06, 0xA2, 0x6D, 0x70, 0x2B, 0xA6, 0xA7, 0x65, 0xA9, 0x2B, 0xA1, 0xAC, 0x53, 0xA4, 0x2F, 0x9C, 0xB1, 0x53, 0x9F, 0x2E, 0x97, 0xB6, 0x54, 0x9A,
	0x2F, 0x7C, 0xBB, 0x53, 0x7F, 0x2E, 0x8D, 0xC0, 0x48, 0x90, 0x2D, 0x88, 0xB6, 0x8B, 0x8C, 0xB0, 0xA2, 0x85, 0x33, 0xBF, 0xB1, 0xC2, 0x32, 0xC9, 0x9D, 0xCB, 0x34, 0x6A, 0xA7, 0x6F, 0x37, 0xD9,
	0x98, 0xDB, 0x39, 0x77, 0x8E, 0x7A, 0x3C, 0x5A, 0x7D, 0x5F, 0x4F, 0x51, 0x73, 0x57, 0x4F, 0x13, 0x04, 0x0A, 0x45, 0x5B, 0x4A, 0x09, 0x0A, 0xC7, 0xEC, 0x14, 0x3F, 0xF6, 0xF9, 0xFA, 0xFB, 0xFC,
	0xFD, 0xFE, 0xFF, 0x00, 0x03, 0x0A, 0x1C, 0x48, 0xB0, 0xA0, 0xC1, 0x83, 0x08, 0x4D, 0x44, 0x00, 0x00, 0x3B, 
};

static char Image2[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF2, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0xD4, 0xD4, 0xD4, 0xB8, 0xB8, 0xB8, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x2C, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x03, 0xB8, 0x28, 0xBA, 0xDC, 0xFE, 0x30, 0xCA, 0x49, 0xAB, 0xBD, 0x38, 0xEB, 0xCD, 0xBB, 0xFF, 0x60,
	0x28, 0x8E, 0x64, 0x69, 0x9E, 0x68, 0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70, 0x2C, 0xCF, 0x74, 0xDD, 0x10, 0x43, 0xAE, 0xEF, 0x7C, 0xEF, 0xE7, 0x04, 0xD4, 0x20, 0x40, 0x2C, 0x1A, 0x8F, 0xC8, 0x24,
	0x71, 0x20, 0x54, 0x3A, 0x9F, 0x45, 0xE6, 0x69, 0x08, 0xAD, 0x22, 0xA5, 0x26, 0xAA, 0x75, 0x1B, 0xC0, 0x96, 0xB4, 0xDC, 0xAA, 0x97, 0x04, 0x0E, 0x3F, 0xC7, 0xA3, 0xB2, 0x59, 0x89, 0x16, 0xA9,
	0xD7, 0xD7, 0x26, 0xFC, 0x2C, 0x9F, 0xB3, 0xEB, 0xF6, 0xF8, 0x34, 0x7F, 0xDF, 0xF3, 0xF5, 0x59, 0x7F, 0x80, 0x5F, 0x82, 0x47, 0x6D, 0x21, 0x6F, 0x7C, 0x87, 0x20, 0x89, 0x79, 0x8B, 0x1F, 0x8D,
	0x76, 0x8F, 0x1E, 0x91, 0x73, 0x93, 0x1D, 0x95, 0x70, 0x97, 0x1C, 0x99, 0x6B, 0x9B, 0x1B, 0x9D, 0x66, 0x9F, 0x1A, 0xA1, 0x61, 0xA3, 0x19, 0xA5, 0x5C, 0xA7, 0x18, 0xA9, 0x5B, 0xAB, 0x17, 0xAD,
	0x56, 0xAF, 0x16, 0xB1, 0x62, 0x78, 0x85, 0xB3, 0x15, 0xB5, 0x50, 0xB9, 0x14, 0xBB, 0x74, 0x27, 0x38, 0x3F, 0xC3, 0xC4, 0x40, 0x36, 0xC7, 0xC8, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF, 0xD0,
	0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD7, 0xD3, 0x09, 0x00, 0x3B, 
};

static char Image3[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF2, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x64, 0x64, 0x98, 0x68, 0x68, 0x68, 0xA0, 0xA0, 0xA0, 0x98,
	0x98, 0x98, 0x84, 0x84, 0x84, 0x2C, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x03, 0xC0, 0x28, 0xBA, 0xDC, 0xFE, 0x30, 0xCA, 0x49, 0xAB, 0xBD, 0x38, 0xEB, 0xCD, 0xBB, 0xFF, 0x60,
	0x28, 0x8E, 0x64, 0x69, 0x9E, 0x68, 0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70, 0xAC, 0x10, 0x85, 0xBC, 0x11, 0x41, 0x50, 0xDB, 0x17, 0x9E, 0xEB, 0xBC, 0x8A, 0xEF, 0x07, 0x0C, 0x46, 0x86, 0xC4, 0xC0,
	0xC1, 0xF8, 0x18, 0x24, 0x93, 0x03, 0x26, 0xC3, 0xF9, 0x84, 0x4A, 0x05, 0xD4, 0xAA, 0xD5, 0x98, 0xD5, 0x6E, 0x6D, 0x5D, 0xEF, 0x17, 0x16, 0x16, 0x8F, 0x5B, 0x65, 0xF3, 0x59, 0x95, 0x56, 0xAF,
	0x4F, 0x48, 0xB7, 0x97, 0xB0, 0x32, 0xC8, 0xE5, 0x86, 0x54, 0xE1, 0x7E, 0xDF, 0x95, 0xF6, 0x7C, 0x7D, 0x7F, 0x81, 0x81, 0x7E, 0x20, 0x80, 0x84, 0x7C, 0x86, 0x1E, 0x71, 0x89, 0x6A, 0x74, 0x22,
	0x8D, 0x8E, 0x5A, 0x90, 0x23, 0x92, 0x93, 0x44, 0x95, 0x24, 0x97, 0x98, 0x9A, 0x25, 0x9C, 0x89, 0x9E, 0x26, 0xA0, 0x7C, 0xA2, 0x27, 0x6D, 0x7C, 0x51, 0x2E, 0xA8, 0x6E, 0xAA, 0x2F, 0xAC, 0x62,
	0xAE, 0x64, 0x84, 0xB2, 0x31, 0xB0, 0x6F, 0xB3, 0xAD, 0x57, 0xB7, 0xB5, 0x5C, 0xB1, 0x57, 0x0C, 0x97, 0x79, 0xC0, 0xC1, 0x4F, 0x8B, 0xC4, 0x02, 0x48, 0xC7, 0xC8, 0xC9, 0x39, 0xCB, 0xCC, 0xC9,
	0xCF, 0xD0, 0xD3, 0xD4, 0xD5, 0xD6, 0xD7, 0xD8, 0xD9, 0xDA, 0xDB, 0xDC, 0xDD, 0xDE, 0xDF, 0x10, 0x09, 0x00, 0x3B, 
};

static char Image4[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF4, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0xF0, 0xF0, 0xF0, 0x30, 0x64, 0x64, 0xAC, 0xAC, 0xAC, 0x30,
	0x30, 0x64, 0x78, 0x78, 0x78, 0x84, 0x84, 0x84, 0xB8, 0xB8, 0xB8, 0x90, 0x90, 0x90, 0xE4, 0xE4, 0xE4, 0xA0, 0xA0, 0xA0, 0xD4, 0xD4, 0xD4, 0x64, 0x64, 0x64, 0x68, 0x68, 0x68, 0x5C, 0x5C, 0x5C,
	0xCC, 0xCC, 0xCC, 0x98, 0x98, 0x98, 0xC8, 0xC8, 0xC8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2C, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x05, 0xFA, 0xA0, 0x20, 0x8E, 0x64, 0x69, 0x9E, 0x68,
	0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70, 0x2C, 0xCF, 0x74, 0x6D, 0xDF, 0x78, 0xAE, 0xEF, 0x7C, 0xEF, 0xFF, 0xC0, 0xA0, 0x70, 0x48, 0x2C, 0x1A, 0x8F, 0xC8, 0xE4, 0xC8, 0xA0, 0xA4, 0x3D, 0x14, 0xCD,
	0x59, 0x61, 0x11, 0x8D, 0x19, 0x02, 0x01, 0x42, 0xF5, 0x85, 0xC0, 0x32, 0xB6, 0xAE, 0x06, 0x76, 0x00, 0x66, 0x5D, 0xB1, 0x81, 0x43, 0x59, 0xC5, 0x40, 0x07, 0x12, 0xEB, 0xD4, 0xC2, 0x4D, 0x8E,
	0x9B, 0x1C, 0x6E, 0xAC, 0xDA, 0x4E, 0x4A, 0xE4, 0x03, 0x11, 0x7C, 0x24, 0x7F, 0x58, 0x4C, 0x71, 0x04, 0x88, 0x12, 0x84, 0x01, 0x12, 0x88, 0x5A, 0x45, 0x10, 0x05, 0x05, 0x03, 0x94, 0x95, 0x03,
	0x8B, 0x8B, 0x96, 0x95, 0x92, 0x10, 0x3D, 0x07, 0x97, 0x98, 0xA1, 0xA1, 0x03, 0x7B, 0x3D, 0x04, 0x62, 0xA2, 0xA9, 0x6E, 0x0D, 0x8F, 0x40, 0x05, 0xAA, 0xAA, 0x05, 0x45, 0x07, 0xB0, 0xA1, 0xA5,
	0x44, 0x04, 0xA0, 0xB5, 0x68, 0x03, 0xAD, 0x47, 0x7E, 0xBB, 0x6F, 0x55, 0x5D, 0xB5, 0x08, 0x60, 0xC4, 0xA9, 0xC6, 0x60, 0xAF, 0xB1, 0x65, 0xBA, 0xA2, 0x75, 0x55, 0x04, 0xBB, 0xBE, 0x4A, 0x0A,
	0xBB, 0x50, 0x55, 0x13, 0x84, 0x03, 0xA8, 0x79, 0x13, 0x5B, 0x84, 0x09, 0x4C, 0xD7, 0x7F, 0x55, 0x0F, 0x79, 0xA4, 0x24, 0x0E, 0x73, 0x6E, 0x0F, 0x51, 0x6D, 0x68, 0xE3, 0x27, 0xCC, 0x5E, 0x51,
	0xED, 0x69, 0x2A, 0x0E, 0xA0, 0x54, 0x4A, 0x67, 0x11, 0x86, 0x54, 0x18, 0x00, 0x16, 0xF0, 0x08, 0x82, 0x01, 0xD9, 0x5C, 0x7C, 0x52, 0x86, 0x44, 0x41, 0xB5, 0x16, 0x04, 0x12, 0x0A, 0x9A, 0x48,
	0xB1, 0xA2, 0xC5, 0x8B, 0x18, 0x33, 0x6A, 0xDC, 0xC8, 0xB1, 0xA3, 0xC7, 0x8F, 0x20, 0x43, 0x8A, 0x14, 0x19, 0x02, 0x00, 0x3B, 
};

static char Image5[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF4, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x30, 0x30, 0x64, 0xF0, 0xF0, 0xF0, 0xD4, 0xD4, 0xD4, 0x30,
	0x64, 0x64, 0x90, 0x90, 0x90, 0x84, 0x84, 0x84, 0x98, 0x98, 0x98, 0xAC, 0xAC, 0xAC, 0xB8, 0xB8, 0xB8, 0x68, 0x68, 0x68, 0xE4, 0xE4, 0xE4, 0xC8, 0xC8, 0xC8, 0x64, 0x64, 0x64, 0x78, 0x78, 0x78,
	0xCC, 0xCC, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2C, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x05, 0xFE, 0xA0, 0x20, 0x8E, 0x64, 0x69, 0x9E, 0x68,
	0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70, 0x2C, 0xCF, 0x74, 0x6D, 0xDF, 0x78, 0xAE, 0xEF, 0x7C, 0xEF, 0xFF, 0xC0, 0xA0, 0x70, 0x48, 0x2C, 0x1A, 0x8F, 0xC8, 0xE4, 0x68, 0xA0, 0xA4, 0x19, 0x0E, 0xCD,
	0x99, 0xA2, 0x10, 0x95, 0x11, 0x02, 0x86, 0xEA, 0x8B, 0x11, 0x08, 0x40, 0xB5, 0x2D, 0x45, 0x97, 0x0A, 0x5E, 0x0D, 0xBA, 0x5D, 0x66, 0x39, 0x05, 0x41, 0x7B, 0xD7, 0x29, 0x87, 0x9B, 0x0C, 0x2F,
	0x9D, 0xDD, 0xD8, 0x28, 0x82, 0xE0, 0x48, 0x20, 0xB2, 0x25, 0x07, 0x78, 0x6F, 0x25, 0x06, 0x08, 0x09, 0x0E, 0x04, 0x08, 0x41, 0x0B, 0x6E, 0x04, 0x04, 0x0A, 0x08, 0x0C, 0x03, 0x05, 0x83, 0x05,
	0x03, 0x0C, 0x08, 0x0A, 0x8F, 0x6E, 0x0B, 0x43, 0x8D, 0x83, 0xA1, 0xA2, 0x9D, 0x44, 0x03, 0x0D, 0xA3, 0xA8, 0x78, 0x0D, 0x6A, 0x43, 0xA6, 0xA9, 0xA9, 0xAB, 0x47, 0x06, 0x57, 0xAF, 0xA1, 0x04,
	0x80, 0x47, 0x0F, 0xB5, 0xA1, 0x0F, 0x4D, 0x6D, 0xBB, 0x68, 0x10, 0x55, 0x09, 0xC0, 0x01, 0x09, 0x5A, 0x11, 0xC5, 0x11, 0xC3, 0xC5, 0x5D, 0xC7, 0x4A, 0x82, 0xCD, 0x5D, 0x5F, 0xB9, 0xB4, 0xD2,
	0x04, 0xBD, 0x46, 0x77, 0xD2, 0x6E, 0xAC, 0x42, 0xAE, 0xDC, 0x6E, 0xB1, 0x43, 0x95, 0xE1, 0x78, 0x74, 0x40, 0xA0, 0x5D, 0x8F, 0x91, 0x93, 0xE5, 0x73, 0x98, 0x9A, 0x9C, 0x68, 0x9E, 0x40, 0x09,
	0x7C, 0x7E, 0xB8, 0x23, 0xD1, 0x6E, 0xD4, 0x23, 0x86, 0x88, 0x08, 0x3C, 0x53, 0x62, 0x60, 0x90, 0xBE, 0x3A, 0x22, 0xE4, 0xA0, 0x41, 0x87, 0x50, 0xC4, 0xAF, 0x69, 0x0D, 0xED, 0x74, 0x8B, 0x58,
	0x02, 0x14, 0x43, 0x8A, 0x5C, 0x08, 0x51, 0x24, 0x71, 0xE5, 0xE0, 0xC6, 0x29, 0x1B, 0x4D, 0x3C, 0xF0, 0x17, 0x52, 0x84, 0xB7, 0x92, 0x28, 0x0F, 0x53, 0xAA, 0x5C, 0xC9, 0xB2, 0xA5, 0xCB, 0x97,
	0x30, 0x63, 0xCA, 0x9C, 0xB9, 0x23, 0x04, 0x00, 0x3B, 
};

static char Image6[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF4, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x68, 0x68, 0x68, 0x30, 0x30, 0x64, 0xF0, 0xF0, 0xF0, 0x30,
	0x64, 0x64, 0xD4, 0xD4, 0xD4, 0xA0, 0xA0, 0xA0, 0xE4, 0xE4, 0xE4, 0xB8, 0xB8, 0xB8, 0xC8, 0xC8, 0xC8, 0x64, 0x64, 0x64, 0xAC, 0xAC, 0xAC, 0x84, 0x84, 0x84, 0x98, 0x98, 0x98, 0x78, 0x78, 0x78,
	0xCC, 0xCC, 0xCC, 0x90, 0x90, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2C, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x05, 0xCD, 0xA0, 0x20, 0x8E, 0x64, 0x69, 0x9E, 0x68,
	0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70, 0x2C, 0xCF, 0x74, 0x6D, 0xDF, 0x78, 0xAE, 0xEF, 0x7C, 0xEF, 0xFF, 0xC0, 0xA0, 0x70, 0x48, 0x2C, 0x1A, 0x8F, 0xC8, 0xA4, 0x88, 0x00, 0x51, 0xD2, 0x1A, 0x07,
	0xA7, 0xCC, 0x10, 0x08, 0x48, 0xA4, 0xB0, 0x43, 0xB5, 0x80, 0x75, 0x41, 0xAA, 0xD5, 0x46, 0x97, 0x55, 0x00, 0x57, 0x0D, 0xE3, 0x54, 0xC3, 0x5C, 0x8D, 0xA4, 0x4F, 0x04, 0x36, 0x98, 0xF1, 0x2E,
	0x2D, 0xE4, 0xD5, 0x68, 0x5D, 0x34, 0xC0, 0x83, 0x1D, 0x7B, 0x02, 0x09, 0x7E, 0x55, 0x09, 0x04, 0x75, 0x08, 0x84, 0x60, 0x08, 0x6F, 0x04, 0x65, 0x8A, 0x01, 0x05, 0x68, 0x63, 0x0A, 0x90, 0x60,
	0x0A, 0x63, 0x0C, 0x96, 0x66, 0x74, 0x58, 0x5A, 0x9B, 0x79, 0x58, 0x0E, 0xA0, 0x66, 0x80, 0x4A, 0x8E, 0xA4, 0x60, 0x05, 0x87, 0x49, 0x89, 0xA9, 0x8B, 0x49, 0x54, 0xAF, 0x66, 0x93, 0x46, 0x77,
	0xB3, 0x60, 0x0B, 0x47, 0x7D, 0xB8, 0x66, 0x03, 0x46, 0x83, 0xBD, 0x60, 0x09, 0x45, 0x0F, 0xC2, 0x6C, 0x0F, 0x43, 0xA8, 0xC7, 0xAA, 0xAC, 0x40, 0x95, 0xCC, 0x66, 0x98, 0x40, 0xB2, 0xD1, 0xB4,
	0x40, 0x9F, 0xD6, 0x60, 0x7A, 0x3E, 0x03, 0xDE, 0xDF, 0xE0, 0xE1, 0xE2, 0xE3, 0xE0, 0x81, 0xE6, 0xE7, 0xE8, 0xE9, 0xEA, 0xEB, 0xEC, 0xED, 0xEE, 0xEF, 0xF0, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6,
	0xF7, 0xF8, 0xF9, 0xFA, 0x6F, 0x21, 0x00, 0x3B, 
};

static char Image7[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF4, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x30, 0x64, 0x64, 0x30, 0x30, 0x64, 0xF0, 0xF0, 0xF0, 0x68,
	0x68, 0x68, 0xC8, 0xC8, 0xC8, 0xB8, 0xB8, 0xB8, 0xAC, 0xAC, 0xAC, 0x78, 0x78, 0x78, 0x90, 0x90, 0x90, 0x84, 0x84, 0x84, 0xE4, 0xE4, 0xE4, 0xD4, 0xD4, 0xD4, 0x64, 0x64, 0x64, 0x98, 0x98, 0x98,
	0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2C, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x05, 0xEB, 0xA0, 0x20, 0x8E, 0x64, 0x69, 0x9E, 0x68,
	0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70, 0x2C, 0xCF, 0x74, 0x6D, 0xDF, 0x78, 0xAE, 0xEF, 0x7C, 0xEF, 0xFF, 0xC0, 0xA0, 0x70, 0x48, 0x2C, 0x1A, 0x8F, 0xC8, 0xA4, 0x68, 0x81, 0x50, 0xCA, 0x08, 0x8E,
	0x40, 0xA0, 0xF1, 0x70, 0xBA, 0x14, 0x05, 0xA9, 0x16, 0x62, 0x55, 0x11, 0x10, 0xDA, 0x70, 0xC0, 0x41, 0xE8, 0x9A, 0x0C, 0x0D, 0xB1, 0xDA, 0x60, 0x1E, 0x45, 0xD4, 0xF0, 0x40, 0xC2, 0x3C, 0x88,
	0xC6, 0xE1, 0x8E, 0x81, 0x73, 0x71, 0xEF, 0x07, 0x16, 0x48, 0x5F, 0x7E, 0x7E, 0x08, 0x65, 0x44, 0x0F, 0x69, 0x83, 0x7E, 0x54, 0x43, 0x0B, 0x59, 0x8A, 0x83, 0x05, 0x80, 0x40, 0x07, 0x90, 0x96,
	0x01, 0x07, 0x3E, 0x03, 0x8F, 0x97, 0x90, 0x05, 0x7A, 0x3B, 0x9C, 0x9D, 0x9E, 0x3C, 0x09, 0xA3, 0x97, 0x73, 0x3B, 0x06, 0xA7, 0x96, 0x6C, 0x3C, 0xAC, 0x90, 0x3E, 0xA6, 0xB0, 0x7D, 0xA9, 0x3C,
	0x0A, 0xB4, 0x7D, 0x0A, 0x3E, 0x04, 0xB9, 0x77, 0x86, 0x3D, 0x95, 0xBE, 0x62, 0x99, 0x3F, 0xB8, 0xC3, 0x61, 0xBB, 0x3F, 0xBD, 0xC8, 0x5A, 0xC0, 0x3E, 0xC2, 0xC8, 0xC5, 0x40, 0x0C, 0xCD, 0x01,
	0x0C, 0x42, 0xCC, 0xC8, 0xCF, 0x3F, 0xD1, 0xB9, 0xD3, 0x41, 0xD5, 0xC3, 0xD8, 0x43, 0xDA, 0xB9, 0xDC, 0x40, 0x60, 0xB9, 0x4D, 0x45, 0xAB, 0xB9, 0xAE, 0x45, 0xA2, 0xA3, 0x05, 0x48, 0xEA, 0xAC,
	0xEC, 0x46, 0xEE, 0xAC, 0xF0, 0x46, 0x03, 0xFE, 0xFF, 0x00, 0x03, 0x0A, 0x04, 0xD5, 0xA6, 0xA0, 0xC1, 0x83, 0x08, 0x13, 0x2A, 0x5C, 0xC8, 0xB0, 0xA1, 0xC3, 0x87, 0x10, 0x23, 0x4A, 0x9C, 0x48,
	0xB1, 0xA2, 0x95, 0x10, 0x00, 0x3B, 
};

static char Image8[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF3, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x78, 0x78, 0x78, 0x30, 0x30, 0x64, 0xF0, 0xF0, 0xF0, 0x30,
	0x64, 0x64, 0xE4, 0xE4, 0xE4, 0xB8, 0xB8, 0xB8, 0x68, 0x68, 0x68, 0x84, 0x84, 0x84, 0xD4, 0xD4, 0xD4, 0x98, 0x98, 0x98, 0xC8, 0xC8, 0xC8, 0xA0, 0xA0, 0xA0, 0xAC, 0xAC, 0xAC, 0x2C, 0x00, 0x00,
	0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x04, 0xD7, 0x50, 0xC8, 0x49, 0xAB, 0xBD, 0x38, 0xEB, 0xCD, 0xBB, 0xFF, 0x60, 0x28, 0x8E, 0x64, 0x69, 0x9E, 0x68, 0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70,
	0x2C, 0xCF, 0x74, 0x6D, 0xDF, 0x78, 0xAE, 0xEF, 0xB4, 0x31, 0xFC, 0xC0, 0xA0, 0x10, 0x68, 0xE0, 0x1D, 0x02, 0xC8, 0xA4, 0x72, 0x99, 0x3C, 0xEC, 0x1C, 0xCC, 0x68, 0xD4, 0x91, 0x23, 0x14, 0xA4,
	0xD8, 0x64, 0x81, 0x80, 0x43, 0x64, 0xBF, 0x01, 0xC4, 0x2D, 0x01, 0x06, 0x27, 0x6C, 0x8B, 0xF2, 0x77, 0x51, 0x53, 0xA8, 0xC1, 0x8A, 0x99, 0xF5, 0xFD, 0xDD, 0xCA, 0x1E, 0x74, 0xF0, 0x23, 0x66,
	0xC8, 0x97, 0x8B, 0x2F, 0x0D, 0x7E, 0x60, 0x0D, 0x2F, 0x7D, 0x83, 0x66, 0x2E, 0x47, 0x88, 0x5F, 0x4E, 0x2C, 0x03, 0x8C, 0x65, 0x03, 0x2B, 0x73, 0x91, 0x75, 0x5C, 0x29, 0x0C, 0x96, 0x65, 0x0C,
	0x2A, 0x5E, 0x9B, 0x5F, 0x62, 0x29, 0x06, 0x57, 0xA0, 0x52, 0x05, 0x80, 0x99, 0xA6, 0x52, 0x9D, 0x94, 0x8B, 0xAB, 0x4D, 0x98, 0x2B, 0x90, 0xB0, 0x49, 0x93, 0x2E, 0x82, 0xB5, 0x85, 0x86, 0xB5,
	0x01, 0xA9, 0x2E, 0x78, 0xAB, 0x7B, 0x31, 0x95, 0x9B, 0x76, 0x32, 0x6E, 0xA0, 0x71, 0x34, 0x69, 0x96, 0x6C, 0x35, 0x64, 0x96, 0x67, 0x36, 0x9F, 0x88, 0xA2, 0x36, 0xC5, 0x79, 0xC7, 0x37, 0x50,
	0x83, 0x54, 0x3A, 0xAF, 0x6F, 0x8E, 0x3A, 0x3E, 0x43, 0xE6, 0x41, 0xBF, 0x3C, 0xEA, 0xEB, 0xEC, 0xED, 0xEE, 0xEF, 0xF0, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8, 0xF9, 0xFA, 0x31, 0x11,
	0x00, 0x3B, 
};

static char Image9[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF4, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x30, 0x64, 0x98, 0x64, 0x98, 0x98, 0xF0, 0xF0, 0xF0, 0x98,
	0x98, 0xCC, 0x30, 0x64, 0x64, 0xE4, 0xE4, 0xE4, 0xD4, 0xD4, 0xD4, 0x64, 0x64, 0x98, 0x98, 0xCC, 0xCC, 0xC8, 0xC8, 0xC8, 0x30, 0x30, 0x64, 0xB8, 0xB8, 0xB8, 0xCC, 0xCC, 0xCC, 0x98, 0x98, 0x98,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2C, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x05, 0xFE, 0xA0, 0x20, 0x8E, 0x64, 0x69, 0x9E, 0x68,
	0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70, 0x2C, 0xCF, 0x74, 0x6D, 0xDF, 0x78, 0xAE, 0xEF, 0x7C, 0xEF, 0xFF, 0xC0, 0xA0, 0x70, 0x48, 0x2C, 0xF2, 0x1A, 0x84, 0xE4, 0xA0, 0x61, 0x8C, 0x29, 0x1C, 0x81,
	0xA8, 0x34, 0x80, 0x30, 0x0C, 0x9A, 0xAB, 0x41, 0x62, 0xCA, 0x95, 0x32, 0x98, 0x58, 0x13, 0x41, 0x5A, 0x30, 0x10, 0x06, 0x87, 0x43, 0x72, 0x1B, 0x2D, 0x5C, 0xC3, 0xA3, 0x45, 0x14, 0xA1, 0x48,
	0x1D, 0xE4, 0x51, 0x02, 0x5C, 0xC0, 0x66, 0x1C, 0x58, 0x0A, 0x08, 0x79, 0x61, 0x82, 0x01, 0x0B, 0x2F, 0x0D, 0x85, 0x7A, 0x46, 0x06, 0x83, 0x30, 0x89, 0x01, 0x05, 0x60, 0x43, 0x0A, 0x51, 0x06,
	0x27, 0x0A, 0x04, 0x0C, 0x0E, 0x67, 0x26, 0x03, 0x05, 0x01, 0x09, 0x45, 0xA0, 0xA2, 0x25, 0x04, 0xA0, 0x5C, 0x09, 0x6F, 0x23, 0x8D, 0x01, 0x8B, 0x41, 0xAD, 0x7F, 0x24, 0x0C, 0x52, 0x09, 0xB6,
	0x85, 0x6E, 0x25, 0x82, 0x08, 0x43, 0xA0, 0x87, 0xB3, 0x51, 0x0C, 0xAB, 0x02, 0xA7, 0x91, 0xC3, 0x63, 0x01, 0x75, 0x40, 0xB1, 0x24, 0xAD, 0x97, 0x9E, 0xA0, 0x05, 0xB2, 0x22, 0xA0, 0x0C, 0x41,
	0xA0, 0xCF, 0x22, 0x03, 0xC1, 0x29, 0x95, 0x01, 0xD6, 0x23, 0x50, 0x05, 0xCB, 0x51, 0xC3, 0x0F, 0xC6, 0x2A, 0x82, 0xE3, 0xAC, 0x51, 0x40, 0xA0, 0x0F, 0x24, 0x07, 0x96, 0x2B, 0xC8, 0xAB, 0xDE,
	0xC3, 0x3A, 0xF2, 0x01, 0xD9, 0x02, 0x8D, 0x92, 0xCD, 0x91, 0x5E, 0xE9, 0x7B, 0xB5, 0x2D, 0x99, 0x8F, 0x82, 0xAB, 0x1A, 0x54, 0x03, 0x28, 0x65, 0xD5, 0x3C, 0x6D, 0x51, 0x94, 0xF1, 0x40, 0x36,
	0xCD, 0x9B, 0x44, 0x01, 0x51, 0x12, 0xF8, 0x82, 0x68, 0x90, 0xE3, 0x45, 0x1D, 0xAD, 0x48, 0x20, 0x23, 0x81, 0x70, 0x80, 0x49, 0x11, 0xAD, 0xFE, 0x56, 0x21, 0x1C, 0x31, 0xF0, 0x46, 0xC8, 0x11,
	0x23, 0x61, 0x46, 0x32, 0xB1, 0x4B, 0x64, 0x3B, 0x96, 0x8E, 0x6A, 0x14, 0xB4, 0x19, 0x00, 0xE0, 0x3A, 0x99, 0xAE, 0x48, 0xC8, 0x29, 0x25, 0xA2, 0xDE, 0x8D, 0x9D, 0x23, 0x0A, 0x4E, 0x2B, 0x08,
	0x21, 0x29, 0xA9, 0x12, 0xD8, 0x78, 0x4E, 0xA2, 0xA1, 0x14, 0x67, 0x47, 0x11, 0x6C, 0x38, 0x2D, 0x88, 0x36, 0x8D, 0x58, 0x39, 0xA1, 0x33, 0x71, 0xE4, 0x14, 0x20, 0xE8, 0x97, 0x88, 0x03, 0x6C,
	0xC8, 0xE0, 0x7B, 0x4A, 0x22, 0x8A, 0x59, 0x1B, 0xE7, 0xF8, 0xF9, 0x9B, 0x4A, 0x6C, 0x0B, 0x82, 0x05, 0xF8, 0xF0, 0x5C, 0x2C, 0xF8, 0x91, 0x46, 0x23, 0x5E, 0x56, 0xDF, 0xAE, 0xF0, 0xE6, 0xA0,
	0x84, 0x9C, 0x9F, 0x37, 0xEE, 0x31, 0x7C, 0xA5, 0xE2, 0x00, 0x28, 0xC0, 0x2C, 0xA3, 0xEA, 0x10, 0x44, 0x94, 0x5A, 0xC4, 0x15, 0x07, 0x0A, 0xE1, 0x13, 0x37, 0xF1, 0xAB, 0xD3, 0x80, 0xDD, 0x50,
	0x7D, 0x2C, 0xC8, 0x2F, 0x47, 0x4D, 0x92, 0xA8, 0x12, 0x10, 0xE8, 0xAA, 0x80, 0x16, 0x15, 0x7C, 0x0A, 0xC3, 0x76, 0xDE, 0x57, 0x62, 0xC0, 0x39, 0x32, 0x09, 0x0A, 0x65, 0xEC, 0x8A, 0x75, 0xEC,
	0x0E, 0xD7, 0xF8, 0x88, 0xE9, 0x9E, 0x52, 0xE6, 0x44, 0x2B, 0xC1, 0x3B, 0x1C, 0x53, 0xE1, 0xAD, 0x8D, 0xC0, 0x82, 0x4D, 0x04, 0xFA, 0xA2, 0x9C, 0x23, 0x04, 0xD9, 0xD5, 0x18, 0x6C, 0x72, 0x55,
	0x97, 0xC2, 0xB8, 0x85, 0x96, 0x36, 0xC1, 0x7F, 0x7C, 0xCA, 0x18, 0xDE, 0xB8, 0x14, 0x78, 0x4D, 0x06, 0xE8, 0x16, 0x66, 0xA7, 0x58, 0x94, 0xC2, 0x70, 0xDC, 0x07, 0xE0, 0xB4, 0x3A, 0x4D, 0x92,
	0x56, 0xEF, 0xCB, 0x17, 0x39, 0x80, 0xBF, 0xCB, 0x14, 0x07, 0xFA, 0x61, 0x71, 0x07, 0x2A, 0xC4, 0xA9, 0xB6, 0x07, 0x0B, 0x0D, 0x0C, 0x17, 0xA0, 0x04, 0x5D, 0x07, 0x36, 0xE8, 0xE0, 0x83, 0x10,
	0x46, 0x28, 0xE1, 0x84, 0x14, 0x56, 0x68, 0xE1, 0x85, 0x18, 0x66, 0x68, 0x43, 0x08, 0x00, 0x3B, 
};

static char Image10[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF2, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x64, 0x64, 0x98, 0x30, 0x30, 0x64, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x2C, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x03, 0xB8, 0x28, 0xBA, 0xDC, 0xFE, 0x30, 0xCA, 0x49, 0xAB, 0xBD, 0x38, 0xEB, 0xCD, 0xBB, 0xFF, 0x60,
	0x28, 0x8E, 0x64, 0x69, 0x9E, 0x68, 0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70, 0x2C, 0x43, 0x04, 0x61, 0xD6, 0x25, 0x11, 0x04, 0x03, 0x39, 0xEC, 0xB6, 0x91, 0x6E, 0xD7, 0x0B, 0xFD, 0x80, 0xA5, 0x23,
	0x0F, 0xA4, 0x2C, 0x26, 0x77, 0xCB, 0x4E, 0x33, 0x35, 0xDD, 0x54, 0xA9, 0x50, 0xE7, 0xE5, 0xAA, 0xE2, 0x52, 0xBC, 0xDD, 0xAC, 0x05, 0xBC, 0x22, 0x37, 0xCC, 0x65, 0x71, 0x04, 0xCD, 0x32, 0xB3,
	0x5B, 0xE0, 0xB7, 0x8B, 0x2B, 0x7F, 0x55, 0xEB, 0xB0, 0x26, 0x3E, 0xA6, 0x54, 0xCF, 0xBE, 0x50, 0x51, 0x7F, 0x80, 0x7E, 0x83, 0x6B, 0x81, 0x44, 0x86, 0x87, 0x44, 0x7B, 0x73, 0x6A, 0x8D, 0x69,
	0x89, 0x0B, 0x90, 0x28, 0x71, 0x85, 0x33, 0x6E, 0x97, 0x79, 0x9A, 0x0C, 0x94, 0x46, 0x9C, 0x67, 0xA0, 0x58, 0x92, 0x84, 0x82, 0x6D, 0xA2, 0x0F, 0x9E, 0x1A, 0x94, 0xAA, 0x5B, 0xA8, 0x12, 0xAD,
	0xA5, 0x5A, 0xAB, 0xAF, 0x1C, 0xB1, 0x0A, 0xB7, 0x0E, 0x43, 0xA6, 0x1E, 0x4A, 0x41, 0x22, 0x43, 0xB3, 0x1F, 0x47, 0xBF, 0xC0, 0xC5, 0xC6, 0x8A, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF, 0xD0,
	0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD7, 0x2F, 0x09, 0x00, 0x3B, 
};

static char Image11[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF3, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x30, 0x64, 0x64, 0xCC, 0xCC, 0xCC, 0xF0, 0xF0, 0xF0, 0x78,
	0x78, 0x78, 0xB8, 0xB8, 0xB8, 0x64, 0x64, 0x64, 0xC8, 0xC8, 0xC8, 0x84, 0x84, 0x84, 0xE4, 0xE4, 0xE4, 0xAC, 0xAC, 0xAC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2C, 0x00, 0x00,
	0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x04, 0x99, 0x50, 0xC8, 0x49, 0xAB, 0xBD, 0x38, 0xEB, 0xCD, 0xBB, 0xFF, 0x60, 0x28, 0x8E, 0x64, 0x69, 0x9E, 0x68, 0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70,
	0x2C, 0xCF, 0x74, 0x6D, 0xDF, 0x78, 0xAE, 0xEF, 0x7C, 0x3F, 0x1A, 0x07, 0x82, 0xC1, 0xD7, 0x31, 0x04, 0x8E, 0x81, 0x21, 0x51, 0xB3, 0x40, 0x06, 0x16, 0x4B, 0x4D, 0xC1, 0x59, 0x88, 0x66, 0x0E,
	0xCE, 0x83, 0x35, 0x43, 0x38, 0x12, 0xB6, 0x9A, 0xC1, 0x00, 0x4C, 0x2E, 0x9B, 0xCF, 0xE8, 0xB4, 0x7A, 0xCD, 0x6E, 0xBB, 0xDF, 0xF0, 0xB8, 0x7C, 0x4E, 0xAF, 0xEB, 0x06, 0x08, 0x14, 0x62, 0x2C,
	0x4B, 0x1C, 0x0B, 0x7C, 0x22, 0x03, 0x53, 0x01, 0x09, 0x31, 0x0A, 0x54, 0x24, 0x84, 0x47, 0x0A, 0x30, 0x5D, 0x4E, 0x79, 0x21, 0x08, 0x4E, 0x01, 0x5F, 0x2F, 0x58, 0x4E, 0x81, 0x1F, 0x03, 0x94,
	0x5A, 0x2F, 0x46, 0x48, 0x86, 0x23, 0x7E, 0x48, 0x4A, 0x2F, 0x03, 0x0C, 0x04, 0x8D, 0x25, 0x0A, 0x04, 0x0C, 0x9A, 0x76, 0xB1, 0xB2, 0xB3, 0xB4, 0xB5, 0xB6, 0xB7, 0xB8, 0xB9, 0xBA, 0xBB, 0xBC,
	0x34, 0x11, 0x00, 0x3B, 
};

static char Image12[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF3, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x64, 0x98, 0x98, 0x30, 0x64, 0x98, 0x98, 0x98, 0xCC, 0xE4,
	0xE4, 0xE4, 0xF0, 0xF0, 0xF0, 0x64, 0x64, 0x98, 0x30, 0x30, 0x64, 0x98, 0xCC, 0xCC, 0xD4, 0xD4, 0xD4, 0xCC, 0xCC, 0xCC, 0xB8, 0xB8, 0xB8, 0x30, 0x64, 0x64, 0x98, 0x98, 0x98, 0x2C, 0x00, 0x00,
	0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x04, 0xFE, 0x50, 0xC8, 0x49, 0xAB, 0xBD, 0x38, 0xEB, 0xCD, 0xBB, 0xFF, 0x60, 0x28, 0x8E, 0x64, 0x69, 0x9E, 0x68, 0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70,
	0x2C, 0xCF, 0x74, 0x6D, 0xDF, 0x22, 0xB1, 0x2C, 0x04, 0x4E, 0x16, 0x81, 0x40, 0xC1, 0x37, 0x32, 0x04, 0x0D, 0xC4, 0x10, 0x21, 0x18, 0xEC, 0x25, 0x3D, 0x0F, 0x66, 0xE0, 0xF1, 0xF4, 0x30, 0x02,
	0x0A, 0x45, 0x80, 0x51, 0xE5, 0x24, 0x82, 0x08, 0x44, 0x30, 0xD1, 0xD5, 0x0C, 0x02, 0x07, 0xC9, 0x21, 0x30, 0x28, 0x67, 0xAE, 0x0D, 0x49, 0x63, 0xEB, 0xBE, 0x7C, 0x03, 0x08, 0x89, 0x38, 0x40,
	0xAE, 0x53, 0xCE, 0x7C, 0x12, 0x77, 0x6D, 0x7E, 0x13, 0x57, 0x0B, 0x14, 0x0B, 0x74, 0x85, 0x02, 0x0E, 0x41, 0x43, 0x13, 0x40, 0x01, 0x0E, 0x37, 0x92, 0x52, 0x97, 0x98, 0x99, 0x9A, 0x52, 0x90,
	0x28, 0x8A, 0x9B, 0xA0, 0xA1, 0x97, 0x88, 0x29, 0x03, 0x6B, 0x8F, 0x03, 0xA9, 0xAA, 0x92, 0x0A, 0xAA, 0xAA, 0x5A, 0x42, 0xAE, 0xA9, 0x96, 0x07, 0x84, 0x29, 0x04, 0x46, 0x60, 0x15, 0x7B, 0x7D,
	0x14, 0x77, 0x79, 0x14, 0x7B, 0x01, 0x06, 0x4E, 0x2C, 0x96, 0x0A, 0x14, 0x73, 0xA4, 0x16, 0x8A, 0x71, 0x13, 0xB0, 0x42, 0x31, 0x08, 0xA7, 0xC4, 0x6A, 0x6C, 0x18, 0x67, 0x69, 0x02, 0xB8, 0x41,
	0x07, 0xC0, 0x31, 0x04, 0x57, 0x68, 0x03, 0x7B, 0x94, 0x17, 0x8E, 0x78, 0xA6, 0x41, 0x0C, 0xC5, 0x33, 0x05, 0xA7, 0xEB, 0x1A, 0xE2, 0xDD, 0x9D, 0x36, 0xDC, 0x8F, 0x1A, 0x96, 0xD5, 0x44, 0x09,
	0xF3, 0xC8, 0x17, 0xD0, 0x18, 0xF4, 0x22, 0x02, 0x2D, 0x00, 0x0F, 0x0A, 0x3A, 0xA4, 0xFC, 0x7B, 0xB2, 0xA6, 0x41, 0xAE, 0x6B, 0x02, 0x00, 0x0D, 0x9B, 0xA3, 0x2D, 0xC9, 0x9E, 0x1E, 0x73, 0x82,
	0x34, 0xC8, 0x18, 0x20, 0xCE, 0x12, 0x3C, 0x74, 0x4F, 0xB4, 0x20, 0xD1, 0x03, 0x0F, 0xCD, 0x37, 0x23, 0x0B, 0x7D, 0x18, 0xA9, 0x67, 0x29, 0x5A, 0xA4, 0x61, 0x49, 0x3E, 0x3A, 0xE9, 0x87, 0x49,
	0xA0, 0x04, 0x99, 0x44, 0x80, 0x8C, 0x54, 0x67, 0x72, 0x5A, 0x37, 0x42, 0x2B, 0x89, 0x04, 0xB5, 0xB4, 0xA0, 0x4F, 0x82, 0x4F, 0xD1, 0x74, 0xFA, 0xF8, 0x38, 0xE0, 0xA1, 0xAD, 0x09, 0x12, 0x0D,
	0x00, 0x6A, 0x47, 0xA3, 0xE5, 0x30, 0xAA, 0x13, 0xEE, 0x31, 0xA9, 0x47, 0xE3, 0x21, 0x96, 0x81, 0x16, 0x12, 0x14, 0x1C, 0x59, 0xE3, 0xE3, 0x38, 0x0F, 0x3C, 0x03, 0x60, 0x85, 0xC1, 0xED, 0xE0,
	0x87, 0x84, 0xFB, 0x6C, 0x70, 0xFD, 0x30, 0x97, 0x91, 0xDD, 0xBB, 0x78, 0xF3, 0xEA, 0xDD, 0xCB, 0xB7, 0xAF, 0xDF, 0xBF, 0x80, 0x03, 0x0B, 0x1E, 0x4C, 0xF8, 0x44, 0x04, 0x00, 0x3B, 
};

static char Image13[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF3, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x98, 0x98, 0xCC, 0x30, 0x64, 0x98, 0x64, 0x98, 0x98, 0xF0,
	0xF0, 0xF0, 0x64, 0x64, 0x98, 0xD4, 0xD4, 0xD4, 0x30, 0x64, 0x64, 0x30, 0x30, 0x64, 0xE4, 0xE4, 0xE4, 0xC8, 0xC8, 0xC8, 0xCC, 0xCC, 0xCC, 0x98, 0xCC, 0xCC, 0xB8, 0xB8, 0xB8, 0x2C, 0x00, 0x00,
	0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x04, 0xFE, 0x50, 0xC8, 0x49, 0xAB, 0xBD, 0x38, 0xEB, 0xCD, 0xBB, 0xFF, 0x60, 0x28, 0x8E, 0x64, 0x69, 0x9E, 0x68, 0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70,
	0x2C, 0xCF, 0x74, 0x6D, 0xDF, 0x38, 0x9C, 0x14, 0x05, 0xA1, 0xE4, 0x9F, 0x02, 0xC3, 0x10, 0x28, 0x16, 0x11, 0x05, 0xA0, 0xA6, 0xB0, 0x30, 0x3A, 0x8D, 0x86, 0xA4, 0xB2, 0xC2, 0x30, 0x22, 0x06,
	0xBD, 0xC4, 0x61, 0xD0, 0x2C, 0x32, 0xA6, 0x92, 0x04, 0xA2, 0x68, 0x38, 0x60, 0x0E, 0xE3, 0xC0, 0x82, 0x30, 0x4D, 0x33, 0x7E, 0x9A, 0x01, 0x79, 0xA0, 0x4C, 0x34, 0xE8, 0x1D, 0x02, 0x31, 0xF0,
	0xF8, 0x60, 0x95, 0x0A, 0x69, 0x6B, 0x1C, 0x72, 0x01, 0x52, 0x40, 0x0D, 0x46, 0x78, 0x17, 0x07, 0x5D, 0x08, 0x6C, 0x53, 0x85, 0x01, 0x51, 0x15, 0x68, 0x8A, 0x60, 0x13, 0x96, 0x50, 0x08, 0x69,
	0x45, 0x0B, 0x66, 0x98, 0x14, 0x9A, 0x4F, 0x94, 0xA1, 0x17, 0x04, 0x05, 0x0E, 0x0D, 0x0D, 0x3C, 0x36, 0x07, 0xA9, 0x0E, 0x05, 0x70, 0xA6, 0x15, 0x09, 0x0E, 0x7B, 0x4E, 0x0B, 0x03, 0x90, 0xA6,
	0xB6, 0xA4, 0x5D, 0x46, 0x0E, 0xBD, 0x5D, 0x06, 0x03, 0x07, 0x09, 0x61, 0x04, 0x92, 0x06, 0xBC, 0x40, 0x07, 0x56, 0x19, 0x0A, 0x85, 0x65, 0x6D, 0x45, 0x87, 0x19, 0x7A, 0xD6, 0x91, 0xCD, 0x1B,
	0x89, 0x01, 0xC2, 0x1E, 0x03, 0x8B, 0x39, 0x85, 0x83, 0x1A, 0x09, 0x55, 0x01, 0xE3, 0x38, 0x92, 0x0D, 0xDC, 0x61, 0x92, 0xEB, 0x39, 0xCF, 0x46, 0x0D, 0x07, 0x6C, 0x0A, 0x5B, 0xB8, 0xA0, 0x98,
	0xD2, 0xB8, 0x4F, 0x47, 0x90, 0xD1, 0x12, 0x20, 0x0D, 0x98, 0x15, 0x79, 0x2E, 0x78, 0xF0, 0xB8, 0xE7, 0x81, 0xC0, 0x96, 0x5D, 0xEF, 0x12, 0xFE, 0xF3, 0x34, 0x60, 0x96, 0xA9, 0x02, 0x13, 0x49,
	0x21, 0xCC, 0x41, 0xA0, 0x13, 0x03, 0x5E, 0x5A, 0xA8, 0xBC, 0x4D, 0xE2, 0xE7, 0x6C, 0xCF, 0x47, 0x0C, 0x04, 0x44, 0x5E, 0xC3, 0x91, 0x6E, 0x23, 0x85, 0x02, 0x97, 0x94, 0x9C, 0xCC, 0xB3, 0xA7,
	0x81, 0x1F, 0x97, 0x33, 0xD2, 0x31, 0xDB, 0x10, 0xA8, 0x08, 0x4E, 0x19, 0x92, 0x1C, 0x58, 0xA4, 0x30, 0xA0, 0xA6, 0x40, 0x25, 0xD9, 0xBC, 0x14, 0x38, 0x86, 0xEA, 0x56, 0xCC, 0x7E, 0x0F, 0x00,
	0x3E, 0x79, 0x34, 0x50, 0x80, 0x32, 0x83, 0x93, 0x18, 0xAC, 0xAC, 0xAA, 0x00, 0x55, 0x81, 0xA3, 0x55, 0xC3, 0x8A, 0x1D, 0x4B, 0xB6, 0xAC, 0xD9, 0xB3, 0x68, 0xD3, 0xAA, 0x5D, 0xCB, 0xB6, 0xED,
	0x94, 0x08, 0x00, 0x3B, 
};

static char Image14[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF3, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x98, 0x98, 0xCC, 0x30, 0x64, 0x98, 0xE4, 0xE4, 0xE4, 0xC8,
	0xC8, 0xC8, 0x64, 0x98, 0x98, 0xF0, 0xF0, 0xF0, 0x64, 0x64, 0x98, 0x30, 0x64, 0x64, 0xD4, 0xD4, 0xD4, 0x98, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0x30, 0x30, 0x64, 0xB8, 0xB8, 0xB8, 0x2C, 0x00, 0x00,
	0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x04, 0xFE, 0x50, 0xC8, 0x49, 0xAB, 0xBD, 0x38, 0xEB, 0xCD, 0xBB, 0xFF, 0x60, 0x28, 0x8E, 0x64, 0x69, 0x9E, 0x68, 0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70,
	0x2C, 0xCF, 0x74, 0x6D, 0xDF, 0x78, 0xAE, 0xEF, 0x3A, 0x71, 0x0C, 0x86, 0xE0, 0xE1, 0x40, 0xE0, 0x61, 0x14, 0x87, 0x42, 0x60, 0xC9, 0x64, 0x16, 0x06, 0x45, 0xA3, 0x80, 0xC0, 0x68, 0x2E, 0x0B,
	0x58, 0x6B, 0xC0, 0x10, 0xD5, 0x0D, 0x9A, 0x06, 0xA2, 0x63, 0xE2, 0x40, 0x3E, 0x9A, 0x07, 0x9D, 0x81, 0xF9, 0xE8, 0x62, 0x1C, 0x03, 0xC4, 0x72, 0x80, 0x5B, 0x2C, 0x17, 0xEE, 0x8D, 0xA2, 0xB1,
	0x7C, 0xD8, 0xAA, 0x01, 0x74, 0x22, 0x5F, 0x01, 0x0C, 0x34, 0x07, 0x73, 0x25, 0x84, 0x69, 0x31, 0x04, 0x4B, 0x0D, 0x27, 0x76, 0x01, 0x0A, 0x31, 0x6B, 0x08, 0x28, 0x0E, 0x72, 0x86, 0x2F, 0x8E,
	0x81, 0x29, 0x84, 0x79, 0x2A, 0x7C, 0x01, 0x2B, 0x72, 0x82, 0x2D, 0x72, 0x7E, 0x2A, 0x5F, 0x97, 0x2D, 0x9D, 0xA1, 0x25, 0x09, 0x4B, 0x8C, 0x2B, 0x88, 0x05, 0x2D, 0x89, 0x2C, 0x67, 0xB7, 0x2C,
	0xB9, 0x2B, 0x76, 0xA7, 0xA2, 0x01, 0xBC, 0x2B, 0xBE, 0x2A, 0x6B, 0xC4, 0x2A, 0xC0, 0x2D, 0xC8, 0xCC, 0xC3, 0xB8, 0x85, 0x2D, 0xB6, 0xD0, 0xC1, 0x29, 0xAF, 0x2B, 0xB2, 0x01, 0x09, 0x2E, 0x72,
	0x90, 0x2A, 0x55, 0xC9, 0x2B, 0x6B, 0x01, 0x63, 0x28, 0x0A, 0xA6, 0x9C, 0xC6, 0x8A, 0x4B, 0xB0, 0x29, 0x96, 0x94, 0x26, 0x9D, 0x06, 0x8D, 0x57, 0x91, 0xEC, 0x32, 0x88, 0xD1, 0x24, 0x84, 0xD5,
	0x2F, 0xE3, 0x05, 0xF0, 0x40, 0x8C, 0x9A, 0x47, 0x43, 0x81, 0x92, 0x00, 0x08, 0xB6, 0x79, 0x20, 0x20, 0x27, 0xC0, 0x82, 0x1B, 0x0E, 0xCE, 0xDC, 0x51, 0x98, 0x81, 0xC0, 0x28, 0x4F, 0x39, 0x0E,
	0x34, 0x1C, 0xC6, 0x20, 0x41, 0x17, 0x02, 0x30, 0x04, 0x06, 0x1C, 0x1C, 0x46, 0x51, 0x87, 0x46, 0x2D, 0x28, 0x0B, 0xD0, 0x92, 0x92, 0x60, 0x1C, 0x4A, 0x03, 0x25, 0xA5, 0x90, 0x21, 0x90, 0x60,
	0x80, 0x4D, 0x90, 0x32, 0x73, 0xEA, 0xDC, 0xC9, 0xB3, 0xA7, 0xCF, 0x9F, 0x40, 0x83, 0x0A, 0x1D, 0x4A, 0xB4, 0xA8, 0xD1, 0xA3, 0x3D, 0x23, 0x00, 0x00, 0x3B, 
};

static char Image15[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF2, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x98, 0x98, 0xCC, 0x30, 0x64, 0x98, 0xB8, 0xB8, 0xB8, 0x30,
	0x64, 0x64, 0x64, 0x64, 0x98, 0x2C, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x03, 0xB8, 0x28, 0xBA, 0xDC, 0xFE, 0x30, 0xCA, 0x49, 0xAB, 0xBD, 0x38, 0xEB, 0xCD, 0xBB, 0xFF, 0x60,
	0x28, 0x8E, 0x64, 0x69, 0x9E, 0x68, 0xAA, 0xAE, 0x6C, 0xEB, 0xBE, 0x70, 0x2C, 0x43, 0x44, 0x6D, 0xDF, 0x78, 0xAE, 0xE7, 0x46, 0x19, 0xFC, 0xC0, 0xA0, 0x70, 0x48, 0x1C, 0x0E, 0x7C, 0xC5, 0xA4,
	0xD2, 0x88, 0x2C, 0xEC, 0x9E, 0xD0, 0xDA, 0xEF, 0x48, 0x9A, 0x22, 0xA9, 0x23, 0x6B, 0x35, 0x80, 0x15, 0x69, 0xB3, 0xDC, 0xAB, 0x78, 0xDB, 0x0D, 0x7D, 0xBD, 0x61, 0xF2, 0x18, 0x5C, 0x06, 0x9D,
	0xCD, 0x69, 0xF6, 0x1A, 0xDD, 0xFE, 0xBC, 0xDD, 0x71, 0xFA, 0x1C, 0x5E, 0xF7, 0xDC, 0xED, 0x79, 0x7C, 0x7B, 0x78, 0x7D, 0x1D, 0x7F, 0x7E, 0x81, 0x84, 0x83, 0x80, 0x85, 0x1C, 0x87, 0x86, 0x89,
	0x8C, 0x8B, 0x88, 0x8D, 0x1B, 0x8F, 0x8E, 0x91, 0x94, 0x93, 0x90, 0x95, 0x1A, 0x97, 0x96, 0x99, 0x9C, 0x9B, 0x98, 0x9D, 0x19, 0x9F, 0x9E, 0xA1, 0xA4, 0xA3, 0xA0, 0xA5, 0x18, 0xA7, 0xA6, 0xA9,
	0xAC, 0xAB, 0xA8, 0x4B, 0xB5, 0x49, 0xAD, 0x17, 0xB6, 0xBA, 0x44, 0xB8, 0x16, 0x03, 0xBF, 0xC0, 0xC1, 0xC2, 0xC3, 0xC4, 0xC3, 0x07, 0x33, 0xC8, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF, 0xD0,
	0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD7, 0x33, 0x09, 0x00, 0x3B, 
};

static char Image16[] = {
	0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x40, 0x00, 0x40, 0x00, 0xF2, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0x00, 0x30, 0x64, 0x30, 0x64, 0x64, 0xF0, 0xF0, 0xF0, 0x30, 0x64, 0x98, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x2C, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00, 0x03, 0xA9, 0x28, 0xBA, 0xDC, 0xFE, 0x30, 0xCA, 0x49, 0xAB, 0xBD, 0x38, 0xEB, 0xCD, 0xBB, 0xFF, 0x60,
	0x28, 0x8E, 0x64, 0x69, 0x9E, 0x68, 0xAA, 0xAE, 0x6C, 0x8B, 0x0E, 0x85, 0x0B, 0x12, 0x84, 0xEC, 0x0D, 0x41, 0x30, 0xD8, 0x1C, 0xAE, 0xF3, 0x1B, 0xDF, 0x0E, 0x98, 0x11, 0x12, 0x8B, 0xB9, 0xE1,
	0xD1, 0x62, 0x5C, 0x32, 0x93, 0xCE, 0xE7, 0x2F, 0x4A, 0x69, 0x52, 0x25, 0xD6, 0x2B, 0x24, 0xAB, 0x75, 0x70, 0xBB, 0x8C, 0x2F, 0x58, 0x21, 0x1E, 0x97, 0xC1, 0xE7, 0x6E, 0x3A, 0x35, 0x68, 0xBB,
	0xDF, 0xF0, 0x76, 0x21, 0x57, 0x88, 0xDB, 0xDF, 0xA0, 0x01, 0x21, 0xC7, 0xEF, 0xFB, 0xFF, 0x80, 0x81, 0x7C, 0x04, 0x4A, 0x41, 0x7B, 0x82, 0x88, 0x89, 0x80, 0x84, 0x79, 0x77, 0x77, 0x73, 0x01,
	0x75, 0x8E, 0x76, 0x44, 0x6B, 0x57, 0x96, 0x54, 0x98, 0x51, 0x9A, 0x4E, 0x9C, 0x4B, 0x9E, 0x47, 0xA0, 0x95, 0x50, 0x63, 0x5E, 0xA4, 0xA5, 0x61, 0xA7, 0xA8, 0x64, 0xAA, 0xAB, 0xA2, 0x40, 0xAF,
	0x3C, 0xB1, 0x36, 0xB3, 0x32, 0xB5, 0x2E, 0xB7, 0x2E, 0x34, 0xAB, 0x5E, 0x85, 0xBC, 0xBF, 0xC0, 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7, 0xC8, 0x57, 0x09, 0x00, 0x3B, 
};

#define	IEntry( x )	(x), sizeof( x )
typedef struct {
	uchar_t	*p;
	unsigned	sz;
} ImageTab_t;

ImageTab_t ImageTab[] = {
	IEntry( Image1 ),
	IEntry( Image2 ),
	IEntry( Image3 ),
	IEntry( Image4 ),
	IEntry( Image5 ),
	IEntry( Image6 ),
	IEntry( Image7 ),
	IEntry( Image8 ),
	IEntry( Image9 ),
	IEntry( Image10 ),
	IEntry( Image11 ),
	IEntry( Image12 ),
	IEntry( Image13 ),
	IEntry( Image14 ),
	IEntry( Image15 ),
	IEntry( Image16 ),
};

static char *ImagePtr = NULL;
static int	ImageSize = 0;
static int NumColours = 0;
static int	RefreshDelay=0;
static int	TableNumR = 6;
static int	TableNumC = 9;

static int MSTime() {
	unsigned CurrentTime;
	struct timeb tmb;
	ftime( &tmb );
	
	CurrentTime = (tmb.time * 1000) + tmb.millitm;
	if (!CurrentTime) CurrentTime++;
	if (verbose & 4) printf( "[%03d]", ((CurrentTime&0x7FFFFFFF)/100)%1000 );

	return CurrentTime;
}


static int StaticPage( Buffer_t *bptr ) {
	int i, v, ind;
	int r, c;
	char	tbuf[16];
	
	bprintf( bptr, "Content-type: text/html\n" );
	bprintf( bptr, "Pragma: no-cache\n" );
	bprintf( bptr, "Expires: 0\n" );
	bprintf( bptr, "\n" );
	bprintf( bptr, "<html>\n" );
	bprintf( bptr, "<head>\n" );
	if (RefreshDelay) bprintf( bptr, "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"%d\">\n", RefreshDelay );
	bprintf( bptr, "</head>\n" );
	bprintf( bptr, "<body bgcolor=\"#000000\" text=#FFFFD0 link=\"#FFFF40\" vlink=\"#FFFFFF\">\n" );
	bprintf( bptr, "<center>\n" );

	bprintf( bptr, "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n" );
	i = MSTime();
//	i=0;
	for (r=0; r<TableNumR; r++) {
		bprintf( bptr, "<tr>" );
		for (c=0; c<TableNumC; c++) {
			ind = i % (TotalMod*100);
			
			bprintf( bptr, "<td bgcolor=\"#C0C0C0\">" );

			bprintf( bptr, "<img src=\"%s?%d\" height=\"64\" width=\"64\"></td>\n", MyURL, ind );
			i+=1+ColourDiv+BGColourDiv;
		}
		bprintf( bptr, "</tr>" );
	}

	
	bprintf( bptr, "</table>\n" );
	bprintf( bptr, "</center>\n" );
	bprintf( bptr, "</body>\n" );
	bprintf( bptr, "</html>\n" );
	return 0;
}

static int MakeImage( Buffer_t *bptr, int ind ) {
	int i, q, qb, n;
	ulong_t	c, bg, v, r;
	uchar_t	*p;

	i = ind % ImageMod;
	ImagePtr = ImageTab[i].p;
	ImageSize = ImageTab[i].sz;
	
	v = *(ImagePtr + 10);
	NumColours = 2 << (v & 0xF);
	
	
	bprintf( bptr, "Content-type: image/gif\n" );
	bprintf( bptr, "Content-Length: %d\n", ImageSize );
	bprintf( bptr, "Pragma: no-cache\n" );
	bprintf( bptr, "Expires: 0\n" );
	bprintf( bptr, "\n" );

	p = BufferMakeSpace( bptr, ImageSize );
	BufferEnqueue( bptr, ImagePtr, ImageSize );
	ImagePtr = p;
	
	c = Colours[ (ind / ColourDiv) % ColourMod ];
	bg = BGColours[ (ind / BGColourDiv) % BGColourMod ];
	p = ImagePtr + 0x10 - 3;
	for (i=0; i<NumColours; i++) {
		v = *p;
		for (n=16; n>=0; n-=8 ) {
			q = (c>>n) & 0xFF;
			qb = (bg>>n) & 0xFF;
			r = ((v * q) + ((0xFF - v) * qb)) >> 8;
			if (r > 0xFF) r = 0xFF;
			*p = r;
			p++;
		}
	}
	
	return 0;
}

int Make_CS_Page( Channel_t *ChPtr, char *flnm, char *opts, char *extra ) {
	Buffer_t	*bptr;
	char *s, *q;
	int ind=-1;

//	sprintf( MyURL, "%s", getenv( "SCRIPT_NAME" ) );
	sprintf( MyURL, "/%s", flnm );
	
	bptr = &(ChPtr->o);
	
	ImageSize = 0;
	NumColours = 0;
	RefreshDelay=0;
	TableNumR = 6;
	TableNumC = 9;
	
	for (q=opts; q && *q;) {
		s = q;
		if (q = strchr( s, '&' )) *q++ = 0;
		
		switch (*s) {
			case 'd':
				RefreshDelay = strtoul( s+1, NULL, 0 );
				break;
			case 'r':
				TableNumR = strtoul( s+1, NULL, 0 );
				break;
			case 'c':
				TableNumC = strtoul( s+1, NULL, 0 );
				break;
			case 'S':	
				TableNumR = 4;
				TableNumC = 5;
				break;
			case 'B':	
				TableNumR = 15;
				TableNumC = 23;
				break;
			default:
				if (isdigit( *s )) {
					ind = strtoul( s, NULL, 0 );
				}
		}
	}

	if (ind >= 0) MakeImage( bptr, ind );
	else StaticPage( bptr );

	ChPtr->req_status = 200;
	InsertHTTPHeadder( ChPtr, 200 );
	SetRF( ChPtr, RF_Write, RF_Execute );
	return 0;
} 

