/*--------------------------------------------------------------------------
    woddity - WebOddity, Web Server                              
    Copyright (C) 2001 - Robin Burgener, robinb@20q.net                     
                                                                            
    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by    
    the Free Software Foundation; either version 2 of the License, or       
    (at your option) any later version.                                     
                                                                            
    This program is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           
    GNU General Public License for more details.                            
                                                                            
    You should have received a copy of the GNU General Public License       
    along with this program; if not, write to the Free Software             
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               
                                                                            
--------------------------------------------------------------------------*/

#include "woddity.h"

int NumPending;
int MaxPending=10;
int AddPending=2;

typedef struct {
	char	*req;
	char	*host;
	int 	hits;
} RTSequence_t;

#define RTSequenceMAX	1024
int RTSequenceNUM;
RTSequence_t RTSequence[RTSequenceMAX];

VServer_t	*RTVServer;

char *RoboTestList[] = {
"slash/snarf/11-backstreet-ramen.jpg",
"slash/snarf/1by1.gif",
"slash/snarf/Bugbanne.jpg",
"slash/snarf/Image1.gif",
"slash/snarf/Image2.gif",
"slash/snarf/Image3.gif",
"slash/snarf/Image4.gif",
"slash/snarf/Image5.gif",
"slash/snarf/Image6.gif",
"slash/snarf/Image7.gif",
"slash/snarf/May.gif",
"slash/snarf/Red_LineC151.gif",
"slash/snarf/XRed_LineC151.gif",
"slash/snarf/Xslashdotlg.gif",
"slash/snarf/Xtopicslashdot.gif",
"slash/snarf/about.html",
"slash/snarf/advertising.html",
"slash/snarf/affiliate_logo.gif",
"slash/snarf/allgreen.gif",
"slash/snarf/alltmawd.gif",
"slash/snarf/archives.htm",
"slash/snarf/archives_f.gif",
"slash/snarf/award_mining.gif",
"slash/snarf/awards.html",
"slash/snarf/bottom.gif",
"slash/snarf/cam.jpg",
"slash/snarf/cheesyportal.html",
"slash/snarf/civ1.gif",
"slash/snarf/civ2.gif",
"slash/snarf/civ3.gif",
"slash/snarf/civ4.gif",
"slash/snarf/civ5.gif",
"slash/snarf/civ6.gif",
"slash/snarf/civ7.gif",
"slash/snarf/cl.gif",
"slash/snarf/clearlillogo.gif",
"slash/snarf/co_prod_datasheet_diag.gif",
"slash/snarf/code.html",
"slash/snarf/column000204.htm",
"slash/snarf/column000215.htm",
"slash/snarf/column000216.htm",
"slash/snarf/column000303.htm",
"slash/snarf/column000307.htm",
"slash/snarf/column000330.htm",
"slash/snarf/column000405.htm",
"slash/snarf/column000421.htm",
"slash/snarf/column000501.htm",
"slash/snarf/column000512.htm",
"slash/snarf/column000522.htm",
"slash/snarf/column000523.htm",
"slash/snarf/column000613.htm",
"slash/snarf/column000710.htm",
"slash/snarf/column000726.htm",
"slash/snarf/column000802.htm",
"slash/snarf/column000809.htm",
"slash/snarf/column000913.htm",
"slash/snarf/column000918.htm",
"slash/snarf/column000920.htm",
"slash/snarf/column001009.htm",
"slash/snarf/column001019.htm",
"slash/snarf/column001030.htm",
"slash/snarf/column001128.htm",
"slash/snarf/column012899.htm",
"slash/snarf/column021199.htm",
"slash/snarf/column033199.htm",
"slash/snarf/column040799.htm",
"slash/snarf/column041499.htm",
"slash/snarf/column042199.htm",
"slash/snarf/column042799.htm",
"slash/snarf/column050599.htm",
"slash/snarf/column051999.htm",
"slash/snarf/column052799.htm",
"slash/snarf/column060299.htm",
"slash/snarf/column061699.htm",
"slash/snarf/column061799.htm",
"slash/snarf/column062899.htm",
"slash/snarf/column070599.htm",
"slash/snarf/column071299.htm",
"slash/snarf/column072299.htm",
"slash/snarf/column081099.htm",
"slash/snarf/column081899.htm",
"slash/snarf/column090298.htm",
"slash/snarf/column090998.htm",
"slash/snarf/column092499.htm",
"slash/snarf/column092899.htm",
"slash/snarf/column102599.htm",
"slash/snarf/column102699.htm",
"slash/snarf/column102998.htm",
"slash/snarf/column110199.htm",
"slash/snarf/column110398.htm",
"slash/snarf/column111198.htm",
"slash/snarf/column122098.htm",
"slash/snarf/column122998.htm",
"slash/snarf/column991106.htm",
"slash/snarf/column991115.htm",
"slash/snarf/column991124.htm",
"slash/snarf/column991130.htm",
"slash/snarf/column991201.htm",
"slash/snarf/column991203.htm",
"slash/snarf/coollogo.gif",
"slash/snarf/coolsite.gif",
"slash/snarf/csoty.gif",
"slash/snarf/devnet.jpg",
"slash/snarf/dsotn.gif",
"slash/snarf/dustpuppy.gif",
"slash/snarf/eriol_slashdot.jpg",
"slash/snarf/fd.gif",
"slash/snarf/gator.gif",
"slash/snarf/greendot.gif",
"slash/snarf/guardian_sotd.gif",
"slash/snarf/gutter.gif",
"slash/snarf/hof.html",
"slash/snarf/img013.GIF",
"slash/snarf/index.html",
"slash/snarf/innernerd.gif",
"slash/snarf/itmaward.gif",
"slash/snarf/jobs.html",
"slash/snarf/latest.jpg",
"slash/snarf/mibaward.jpg",
"slash/snarf/mutant_slashad.jpg",
"slash/snarf/mymacsotm.gif",
"slash/snarf/newstrolls.css",
"slash/snarf/newstrolls.gif",
"slash/snarf/newstrolls12.gif",
"slash/snarf/perveniobanner.jpg",
"slash/snarf/planetclick.gif",
"slash/snarf/polls_f.gif",
"slash/snarf/pr134.html",
"slash/snarf/prettypictures.html",
"slash/snarf/projectcool.jpg",
"slash/snarf/quicklinks.gif",
"slash/snarf/rotw.jpg",
"slash/snarf/schema2.gif",
"slash/snarf/sdbanner2.gif",
"slash/snarf/sdgrey.gif",
"slash/snarf/sdnerdinside.gif",
"slash/snarf/served.gif",
"slash/snarf/shapiro.gif",
"slash/snarf/shop_f.gif",
"slash/snarf/slashDotBanner.png",
"slash/snarf/slashbanner1.gif",
"slash/snarf/slashbanner2.gif",
"slash/snarf/slashbanner_a.gif",
"slash/snarf/slashbutton.gif",
"slash/snarf/slashdot_breakfast.png",
"slash/snarf/slashdotanim.gif",
"slash/snarf/slashdotbanner.gif",
"slash/snarf/slashdotlg.gif",
"slash/snarf/slashdotnow.gif",
"slash/snarf/slc.gif",
"slash/snarf/slingerzbanner.gif",
"slash/snarf/slingerzbanner2.gif",
"slash/snarf/slingerzbutton1.gif",
"slash/snarf/snarf.html",
"slash/snarf/strike.jpg",
"slash/snarf/supporters.html",
"slash/snarf/threads_f.gif",
"slash/snarf/thumb.jpg",
"slash/snarf/title.gif",
"slash/snarf/title_downes.gif",
"slash/snarf/tlogo6.gif",
"slash/snarf/top.gif",
"slash/snarf/topicamd.gif",
"slash/snarf/topicamiga.gif",
"slash/snarf/topicanime.gif",
"slash/snarf/topicannouncements.gif",
"slash/snarf/topicaol.jpg",
"slash/snarf/topicapache.gif",
"slash/snarf/topicapple.gif",
"slash/snarf/topicbe.gif",
"slash/snarf/topicbeanies.gif",
"slash/snarf/topicbsd.gif",
"slash/snarf/topicbug.jpg",
"slash/snarf/topiccaldera.gif",
"slash/snarf/topiccda.jpg",
"slash/snarf/topiccensorship.gif",
"slash/snarf/topiccomdex.gif",
"slash/snarf/topiccompaq.gif",
"slash/snarf/topiccorel.gif",
"slash/snarf/topicdebian.gif",
"slash/snarf/topicdigital.gif",
"slash/snarf/topicdoj.jpg",
"slash/snarf/topiced.gif",
"slash/snarf/topiceditorial.gif",
"slash/snarf/topicencryption.gif",
"slash/snarf/topicenlightenment.gif",
"slash/snarf/topiceplus.jpg",
"slash/snarf/topicgames.jpg",
"slash/snarf/topicgimp.gif",
"slash/snarf/topicgnome.gif",
"slash/snarf/topicgnu.jpg",
"slash/snarf/topicgnustep.gif",
"slash/snarf/topicgraphics3.gif",
"slash/snarf/topichardware.gif",
"slash/snarf/topichumor.gif",
"slash/snarf/topicibm.gif",
"slash/snarf/topicie.jpg",
"slash/snarf/topicintel.gif",
"slash/snarf/topicinternet.gif",
"slash/snarf/topicjava.jpg",
"slash/snarf/topickde.gif",
"slash/snarf/topiclinux.gif",
"slash/snarf/topiclinuxbiz.gif",
"slash/snarf/topiclinuxcare.gif",
"slash/snarf/topicmandrake.gif",
"slash/snarf/topicmedia.gif",
"slash/snarf/topicmoney.gif",
"slash/snarf/topicmovies.gif",
"slash/snarf/topicmozilla.gif",
"slash/snarf/topicms.gif",
"slash/snarf/topicmusic.gif",
"slash/snarf/topicnetscape.gif",
"slash/snarf/topicnews.gif",
"slash/snarf/topicpatents.gif",
"slash/snarf/topicperl.gif",
"slash/snarf/topicphp.gif",
"slash/snarf/topicpilot.gif",
"slash/snarf/topicprivacy.gif",
"slash/snarf/topicprogramming.gif",
"slash/snarf/topicquake.gif",
"slash/snarf/topicquickies.gif",
"slash/snarf/topicredhat.gif",
"slash/snarf/topics.html",
"slash/snarf/topicscience.gif",
"slash/snarf/topicsgi.gif",
"slash/snarf/topicslashback.gif",
"slash/snarf/topicslashdot.gif",
"slash/snarf/topicspace.gif",
"slash/snarf/topicspam.jpg",
"slash/snarf/topicstarwars.gif",
"slash/snarf/topicsun.gif",
"slash/snarf/topicsuse.gif",
"slash/snarf/topictech2.jpg",
"slash/snarf/topictoys.gif",
"slash/snarf/topictransmeta.gif",
"slash/snarf/topicturbolinux.gif",
"slash/snarf/topictv.jpg",
"slash/snarf/topicunix.jpg",
"slash/snarf/topicupgrades.gif",
"slash/snarf/topicus.gif",
"slash/snarf/topicva.gif",
"slash/snarf/topicwine.gif",
"slash/snarf/topicx.jpg",
"slash/snarf/topicximian.gif",
"slash/snarf/topicxmas.jpg",
"slash/snarf/tre_slashdot_org_anim_button.gif",
"slash/snarf/tre_slashdot_org_button.gif",
"slash/snarf/tre_slashdot_org_button_2.gif",
"slash/snarf/ulaward.gif",
"slash/snarf/usathot.gif",
"slash/snarf/usertrolls_f.gif",
"slash/snarf/wbw.jpg",
"slash/snarf/webaward2.gif",
"slash/snarf/webtrips.gif",
"slash/snarf/whaward3.gif",
"slash/snarf/whois_f.gif",
NULL };

RTSequence_t *GetRTSequence() {
	if (RTSequenceNUM >= RTSequenceMAX) {
		return NULL;
	}
	return &(RTSequence[RTSequenceNUM++]);
}

int AttachRTSequence( char *req, char *host ) {
	RTSequence_t	*SPtr;
	
	if ((SPtr = GetRTSequence()) == NULL) return -1;
	SPtr->req = strperm( req );
	SPtr->host = strperm( host );

	if (verbose & 2) printf( "Attach Seq - http://%s/%s\n", SPtr->host, SPtr->req );
	return 0;
}

RTSequence_t *ChooseRTSequence() {
	int i, r;
	int vmin=0, vmax=0, vlim=0, vtot=0;
	RTSequence_t	*SPtr;
	
	for (i=0, SPtr = RTSequence; i<RTSequenceNUM; i++, SPtr++) {
		if ((vmax == 0) || (SPtr->hits > vmax)) vmax = SPtr->hits;
		if ((vmin == 0) || (SPtr->hits < vmin)) vmin = SPtr->hits;
	}
	vlim = vmax+1;
	for (i=0, SPtr = RTSequence; i<RTSequenceNUM; i++, SPtr++) {
		vtot += vlim - SPtr->hits;
	}
	if ((r = vtot) > 1) r = (rand() % vtot) + 1;
//	printf( "CRTS %d / %d ", r, vtot );
	for (i=0, SPtr = RTSequence; i<RTSequenceNUM; i++, SPtr++) {
		r -= vlim - SPtr->hits;
		if (r <= 0) {
			SPtr->hits++;
//			printf( "CRTS %d @ %d *** ", i, SPtr->hits );
			return SPtr;
		}
	}
	if (verbose) printf( "ChooseRTSequence ERROR\n" );
	return NULL;
}



#define	ContentLength "Content-length:"

int RT_TestHTTPRequest( Channel_t *ChPtr ) {
	time_t	tv;
	char	time_buf[64];
	char tbuf[256];
	char *reqt, *cmd;
	char *s, *d, *ln, *q;
	char *content;
	int	HeadSize, i;
	int	CurContentLength=0;
	int	HeadContentLength=0;
	Buffer_t	*bptr;
	
	bptr = &(ChPtr->i);
	
	s = _BufReadPtr( bptr );
	if ((d = strchr( s, 0x0A )) == NULL) return -1;
	memset( tbuf, 0, sizeof( tbuf ) );
	strncpy( tbuf, s, min( (d-s), sizeof( tbuf ) ) );
	
	if ((d = strstr( s, "\x0D\x0A\x0D\x0A" )) != NULL) {
		content = d+4;
	} else if ((d = strstr( s, "\x0A\x0A" )) != NULL) {
		content = d+2;
	}

	if (d == NULL) {
		if (verbose&8) printf( "*** Incomplete Headder ***\n" );
		return 0;
	}
	HeadSize = (content - s);
	CurContentLength = _BufSize( bptr ) - HeadSize;
	ChPtr->content_offset = HeadSize;
	
	if (s = strstr( _BufReadPtr( bptr ), ContentLength )) {
		s += strlen( ContentLength );
		while (*s && (*s >= 0x20) && !isdigit( *s )) s++;
		if (isdigit( *s )) {
			HeadContentLength = strtoul( s, NULL, 0 );
			ChPtr->content_length = HeadContentLength;
		}
		if (verbose & 4) printf( "Content-Length: %d of %d\n", CurContentLength, HeadContentLength );
		if (CurContentLength < HeadContentLength) {
			if (verbose&8) printf( "*** Incomplete Content ***\n" );
			return 0;
		}
	}

	if (verbose&1) printf( "RECEIVED REQUEST: %s\n", tbuf );

	if (verbose & 8) {
		if ((i = _BufSize( &(ChPtr->i ))) > 64) i = 64;
		HexDump( _BufReadPtr( &(ChPtr->i )), i );
	}
	ClearRF( ChPtr, RF_Read );
//	ChannelDistroy( ChPtr, 0 );	
	return 0;
}


int RTSocketRead( Buffer_t *bptr, int fd, int free_space ) {
	char	*p;
	int n, r;

	for (r=0; r<3; r++) {
		p = BufferMakeSpace( bptr, READBUF_MIN );			
		if ((n = read( fd, p, BufferFreeSpace( bptr ))) <= 0) {
			if (errno == EINTR) continue;
			return n;
		}
		BufferEnqueue( bptr, NULL, n );
		return n;
	}
	return -1;
}

int ChEventRT_TCP( Channel_t *ChPtr, unsigned chev, int stat ) {
	int n, r, t, retry;
	Buffer_t	*bptr;
	char	*p;

	switch (chev) {
		case CHEV_Read:
			if (!ChPtr->fdr) return 0;
			
			if (ChPtr->SPtr) bptr = &(ChPtr->SPtr->o);
			else bptr = &(ChPtr->i);
			
			if ((n = SocketRead( bptr, ChPtr->fdr, READBUF_MIN )) <= 0) {
				RFDclose( ChPtr->fdr );
				ChPtr->fdr = 0;
				SetRF( ChPtr, RF_Query, RF_Read );
				return 0;
			}
			
			if (verbose & 8) printf( "Read %d   %d bytes\n", ChPtr->idx, n );

			SetRF( ChPtr, RF_Query, 0);
			break;
		case CHEV_Write: 
			if (ChPtr->SPtr) bptr = &(ChPtr->SPtr->i);
			else bptr = &(ChPtr->o);
			
			for (retry=0; ; retry++) {
				if ((n = BufferLength( bptr )) > WRITE_MAX) n = WRITE_MAX;
				if (n == 0) return 0;
				r = write( ChPtr->fdw, BufferDequeue( bptr, 0), n );
				if (r >= 0) break;
				if (errno == EINTR) {
					if (retry >= 5) return 0;
					continue;
				}
				if (verbose & 2) printf( "ERROR in Write %d   rslt %d, errno %d\n", ChPtr->idx, r, errno );
				RFDclose( ChPtr->fdw );
				ChPtr->fdw = 0;
				SetRF( ChPtr, 0, RF_Write );
				return 0;
			}
						
			if (verbose & 8) printf( "Write %d   %d bytes - result: %d\n", ChPtr->idx, n, r );
			if (r > 0) {
				BufferDequeue( bptr, r );
				ChPtr->total_write += r;
				if (BufferLength( bptr ) == 0) {
					SetRF( ChPtr, RF_Read, RF_Write );
				}
			}
			break;
		case CHEV_ReadE: 
			if (ChPtr->SPtr) bptr = &(ChPtr->SPtr->e);
			else bptr = &(ChPtr->e);
	
			if ((n = SocketRead( bptr, ChPtr->fde, READBUF_MIN )) <= 0) {
				RFDclose( ChPtr->fde );
				ChPtr->fde = 0;
				return 0;
			}
			log_error( ChPtr, _BufWritePtr( bptr ) - n );
			break;
		case CHEV_Query: 
			ClearRF( ChPtr, RF_Query );
			RT_TestHTTPRequest( ChPtr );
			break;
		case CHEV_Expire: 
			if (ChPtr->thread_pid) kill( ChPtr->thread_pid, SIGINT );
			else ChannelDistroy( ChPtr, 0 );
			break;
		case CHEV_Init: 
			ChPtr->expire = WTMinute;
			NumPending++;
			break;
		case CHEV_Close: 
			shutdown( ChPtr->fdr, 0 );
#if 0
			AddMetric( &RTmetric_xfer, ChPtr->total_write );
			if (ChPtr->create_time) {
				AddMetric( &RTmetric_time, ChPtr->total_time );
			}
			if (last_RTtime) {
				t = GetCurrentTime() - last_RTtime;
				AddMetric( &metric_RTrate, t );
			} 
			last_RTtime = GetCurrentTime();
#endif
			if (ChPtr->VSPtr) {		// per VServer metrics
				if (ChPtr->total_time) AddMetric( &(ChPtr->VSPtr->metric_time), ChPtr->total_time );
				if (ChPtr->total_write) AddMetric( &(ChPtr->VSPtr->metric_xfer), ChPtr->total_write );
				ChPtr->VSPtr->hit_count++;
			}
			log_req_status( ChPtr );
			
			NumPending--;
			
			if ((stat == 0) && (NumPending < MaxPending)) RTMakeRequest( ChooseRTSequence() );

			break;
	}
	return 0;
}

int RTMakeRequest( RTSequence_t *SPtr ) {
	Channel_t	*ChPtr;
	Buffer_t	*bptr;
	char	tbuf[256];
	char	*s;
	int	opt_v;
	
	if (verbose & 1) printf( "GET http://%s/%s\n", SPtr->host, SPtr->req );
	
	ChPtr = ChannelCreate( NULL, ChType_TCP, ChEventRT_TCP );
	ChPtr->VSPtr = RTVServer;
//	ClearRF( ChPtr, RF_Write | RF_Read | RF_Execute );
	
	if (verbose > 2) printf( "Channel as %d\n", ChPtr->idx );

	if ((ChPtr->fdr = ChPtr->fdw = socket( AF_INET, SOCK_STREAM, 0 )) < 0) {
		perror( "opening socket" );
		ChannelDistroy( ChPtr, 1 );
		return -1;
	}
	if (verbose > 2) printf( "Socket as %d\n", ChPtr->fdr );

	RegFD( ChPtr->fdr, RFD_open | RFD_openTCP, ChPtr->idx );
			
//	opt_v = 1;
//	setsockopt( ChPtr->fdr, SOL_SOCKET, SO_REUSEADDR, &opt_v, sizeof( opt_v ) );

	ChPtr->addr.sin_family = AF_INET;
	
	strcpy( tbuf, SPtr->host );
	if (s = strchr( tbuf, ':')) *s++=0;
	
	inet_aton( tbuf, &(ChPtr->addr.sin_addr) ); 
	if (s) ChPtr->addr.sin_port = htons( strtol( s, NULL, 0 ) );
	else ChPtr->addr.sin_port = htons( 80 );
	
	if (connect( ChPtr->fdr, (struct sockaddr *)&(ChPtr->addr), sizeof( ChPtr->addr ) ) ) {
		perror( "connect" );
		ChannelDistroy( ChPtr, 1 );
		return -1;
	}

	bptr = &(ChPtr->o);

	bprintf( bptr, "GET /%s HTTP/1.0\n", SPtr->req );
	bprintf( bptr, "Accept: */*\n" );
	bprintf( bptr, "Referer: http://%s/%s\n", SPtr->host, SPtr->req );
	bprintf( bptr, "User-Agent: Woddity-RoboTest (compatible; robot)\n" );
	bprintf( bptr, "Host: %s\n", SPtr->host );
	bprintf( bptr, "Connection: Keep-Alive\n" );
	bprintf( bptr, "\n" );


	sprintf( ChPtr->req_log, "GET http://%s/%s", SPtr->host, SPtr->req );
	SetRF( ChPtr, RF_Write, 0 );
	
	if (verbose & 1) printf( "done init GET http://%s/%s\n", SPtr->host, SPtr->req );
	SendKICK( "Req" );
}


char *TCP_port = NULL;
VServer_t	*NewVServer();

main( int argc, char *argv[], char *envp[] ){
	int opt, i;
	char *s;
	char **lp;

	WoddProgName = argv[0];
	
	if (s = strrchr( WoddProgName, '/' )) WoddProgName = s+1;
	
	verbose=1;
	
	while ((opt = getopt( argc, argv, "f:p:m:a:V-" )) != -1 ) {
		switch (opt) {
			case '-':	break;
			case 'f':	ConfigWoddity( optarg );	TCP_port = NULL;	break;
			case 'p':	TCP_port = optarg;			break;
			case 'V':	verbose = (verbose << 1) | 1;	break;
			case 'm':	MaxPending = strtoul( optarg, NULL, 0 );		break;
			case 'a':	AddPending = strtoul( optarg, NULL, 0 );		break;
		}
	}

	RTVServer = NewVServer();
	RTVServer->ServerName = "RoboTest";
	RTVServer->Port = "8080";
	RTVServer->ServerAdmin = "ServerAdmin";
	RTVServer->WWWRoot = "";
	RTVServer->CGIRoot = "";
	RTVServer->USERRoot = "";
	RTVServer->LOGRoot = "/tmp";
	RTVServer->LOGName = "robotest.log";
	RTVServer->DefaultPage = "";
	RTVServer->ChildExpire = 60;

	for (lp = RoboTestList; *lp; lp++) 	AttachRTSequence( *lp, "120.169.1.133:88" );

#if 0
	AttachRTSequence( "robotest.txt", "120.169.1.133:88" );
	AttachRTSequence( "robots.txt", "120.169.1.133:88" );
	AttachRTSequence( "index.html", "120.169.1.133:88" );
//	AttachRTSequence( "robots.txt", "120.169.1.133:80" );
//	AttachRTSequence( "index.html", "120.169.1.133:80" );
	
#endif
	if (TCP_port) StandardConfigWoddity( TCP_port );
	RunWoddity( 1 );
	while (1) {
		sleep( 3 );
		for (i=0; i<AddPending; i++) {
			if (NumPending > MaxPending) break;
			RTMakeRequest( ChooseRTSequence() );
		}
		SendKICK( "Hello" );
	}
}

