/*--------------------------------------------------------------------------
    woddity - WebOddity, Web Server                              
    Copyright (C) 2001 - Robin Burgener, robinb@20q.net                     
                                                                            
    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by    
    the Free Software Foundation; either version 2 of the License, or       
    (at your option) any later version.                                     
                                                                            
    This program is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           
    GNU General Public License for more details.                            
                                                                            
    You should have received a copy of the GNU General Public License       
    along with this program; if not, write to the Free Software             
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               
                                                                            
--------------------------------------------------------------------------*/


#define	__WoddityFD_Module__
#include "woddfd.h"
#include "woddity.h"


static RegFD_t *GetRegFD( int fd ) {
	RegFD_t	*p;
	int	n;
	
	if (fd == 0) fd = -2;
	if (fd > RegFD_maxFD) RegFD_maxFD = fd;
	if (RegFD_num >= RegFD_max) {
		if ((n = (RegFD_max * 2)) == 0) {
			n = 64;
			if ((p = malloc( n * sizeof( RegFD_t ) )) == NULL) return NULL;
		} else {
			if ((p = realloc( RegFD_ptr, n * sizeof( RegFD_t ) )) == NULL) return NULL;
		}
		RegFD_ptr = p;
		p += RegFD_max;
		memset( p, 0, (n-RegFD_max)*sizeof( RegFD_t ) );
		RegFD_max = n;
	}
	for (n=0, p = RegFD_ptr; n<RegFD_max; n++, p++) {
		if (p->fd == fd) return p;
		if (p->fd) continue;
		p->fd = fd;
		if (n >= RegFD_num) RegFD_num = n;
		return p;
	}
	return NULL;
}

int FL_RegFD( char *file, int line, int fd, int typ, int xtra ) {
	RegFD_t	*fdp;
	int	tm;
	
	if ((fdp = GetRegFD( fd )) == NULL) return -1;
	
	fdp->access_tm = tm = GetCurrentTime();
	
	if (typ & RFD_open) {
		fdp->open_tm = tm;
		fdp->pid = getpid();
		strncpy( fdp->open_sfile, file, sizeof( fdp->open_sfile ) );
		fdp->open_sline = line;
		fdp->flags = (fdp->flags & ~RFD_openmode) | (typ & RFD_openmode)  | ((typ & RFD_openmode) << 8) | RFD_fileopen | RFD_open;
		fdp->cidx = xtra;
	}
	if (typ & RFD_close) {
		fdp->close_tm = tm;
		strncpy( fdp->close_sfile, file, sizeof( fdp->close_sfile ) );
		fdp->close_sline = line;
		fdp->flags &= ~RFD_fileopen;
		fdp->flags |= RFD_close;
		fdp->close_stat = xtra;
	}
	if (typ & RFD_staterr) {
		fdp->staterr_tm = tm;
		fdp->flags |= RFD_staterr;
		fdp->staterr_type = xtra;
	}
	return 0;
}

int WFDopen( char *file, int line, char *path_p, unsigned md ) {
	int h;
	
	if ((h = open( path_p, md )) < 0) return h;
	FL_RegFD( file, line, h, RFD_open | RFD_openFD, 0 );
	return h;
}

int WFDclose( char *file, int line, int h ) {
	close( h );
	FL_RegFD( file, line, h, RFD_close, 0 );
	return h;
}



