/*--------------------------------------------------------------------------
    woddity - WebOddity, Web Server                              
    Copyright (C) 2001 - Robin Burgener, robinb@20q.net                     
                                                                            
    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by    
    the Free Software Foundation; either version 2 of the License, or       
    (at your option) any later version.                                     
                                                                            
    This program is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           
    GNU General Public License for more details.                            
                                                                            
    You should have received a copy of the GNU General Public License       
    along with this program; if not, write to the Free Software             
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               
                                                                            
--------------------------------------------------------------------------*/

#ifndef __WoddityFD_Internal_Included__
#define __WoddityFD_Internal_Included__

#ifdef __cplusplus
extern "C" {
#endif

#ifndef	__WoddityFD_Module__
#if 0
#define	open( p, m )	WFDopen( __FILE__, __LINE__, (p), (m) )
#define	close( h )	WFDclose( __FILE__, __LINE__, (h) )
#define	socket( a, b, c )	WFDsocket( __FILE__, __LINE__, (a), (b), (c) )
#define	accept( a, b, c )	WFDaccept( __FILE__, __LINE__, (a), (b), (c) )
#define	bind( a, b, c )	WFDbind( __FILE__, __LINE__, (a), (b), (c) )
#define	listen( a, b )	WFDlisten( __FILE__, __LINE__, (a), (b) )
#define	pipe( a )	WFDpipe( __FILE__, __LINE__, (a) )
#define	fopen( p, m )	WFDfopen( __FILE__, __LINE__, (p), (m) )
#define	fclose( h )	WFDfclose( __FILE__, __LINE__, (h) )
#endif

#define	WFDEXT	extern
#else
#define	WFDEXT
#endif


#define	RFD_fileopen	0x01000000
#define	RFD_open	0x02000000
#define	RFD_close	0x04000000
#define	RFD_staterr	0x08000000
#define	RFD_selRA	0x10000000
#define	RFD_selWA	0x20000000
#define	RFD_selRE	0x40000000
#define	RFD_selWE	0x80000000

#define	RFD_openmode	0xFF
#define	RFD_openmodes	0xFF00
#define	RFD_openFD	0x01
#define	RFD_openTCP	0x02
#define	RFD_openFILE	0x04
#define	RFD_openPIPE0c	0x10
#define	RFD_openPIPE1c	0x20
#define	RFD_openPIPE0	0x40
#define	RFD_openPIPE1	0x80
#define	RFD_openPIPE	(RFD_openPIPE0c | RFD_openPIPE1c | RFD_openPIPE0 | RFD_openPIPE1)

typedef struct {
	int	fd;
	int	flags;
	int	pid, cidx;
	int	access_tm, open_tm, close_tm, staterr_tm, sel_tm, read_tm, write_tm;
	int	staterr_type;
	int	close_stat;
	int	sel_mode;
	char	open_sfile[32];
	int	open_sline;
	char	close_sfile[32];
	int	close_sline;
} RegFD_t;

#define	RegFD( fd, typ, xtra ) FL_RegFD( __FILE__, __LINE__, (fd), (typ), (xtra) )
#define	RFDclose( fd ) FL_RegFD( __FILE__, __LINE__, (fd), (RFD_close), (close( (fd) )) )

WFDEXT	RegFD_t	*RegFD_ptr;
WFDEXT	int	RegFD_num;
WFDEXT	int	RegFD_max;
WFDEXT	int	RegFD_maxFD;

int FL_RegFD( char *file, int line, int fd, int typ, int xtra );


#ifdef __cplusplus
}
#endif

#endif


