/*--------------------------------------------------------------------------
    woddity - WebOddity, Web Server                              
    Copyright (C) 2001 - Robin Burgener, robinb@20q.net                     
                                                                            
    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by    
    the Free Software Foundation; either version 2 of the License, or       
    (at your option) any later version.                                     
                                                                            
    This program is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           
    GNU General Public License for more details.                            
                                                                            
    You should have received a copy of the GNU General Public License       
    along with this program; if not, write to the Free Software             
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               
                                                                            
--------------------------------------------------------------------------*/

#include "woddity.h"

int HTTPError( Channel_t *ChPtr, char *flnm, char *opts, char *extra ) {
	int r=0;
	if (extra) r = strtol( extra, NULL, 0 );
	if (r == 0) r = 404;
	return r;
}

int HTTPRobots( Channel_t *ChPtr, char *flnm, char *opts, char *extra ) {
	Buffer_t	*bptr;
	
	bptr = &(ChPtr->o);

	bprintf( bptr, "User-agent: *\n" );
	bprintf( bptr, "Disallow: %s\n", (extra && *extra)?extra:"" );
	bprintf( bptr, "\n\n" );

	ChPtr->req_status = 200;

	InsertHTTPHeadder( ChPtr, 200 );

	SetRF( ChPtr, RF_Write, RF_Execute );
	return 0;
}

int HTTPReadFile( Channel_t *ChPtr, char *flnm, char *opts, char *content_type ) {
	struct stat statbuf;
	time_t	tv;
	int	h, n, sz, m, tsz;
//	unsigned	hcode;
	char	*p, *tflnm;
	char tbuf[256];
	Buffer_t	*bptr;

	bptr = &(ChPtr->o);
	
	tflnm = flnm;
	if (ChPtr->wservptr->alias) {
		tflnm = ChPtr->wservptr->alias;
	} else {
		if (ChPtr->wservptr && (ChPtr->wservptr->flags & WS_MatchPrefix)) {
			tflnm += ChPtr->wservptr->name_len;
		}
	}

	sprintf( tbuf, "%s/%s", ChPtr->root, tflnm );
	
//	hcode=MakeHCode( tbuf );
	if ((h = open( tbuf, O_RDONLY )) < 0) {
		bprintf( &(ChPtr->e), "Error opening file: %s\n", tbuf );
		if (verbose&2) printf( "ERROR - ReadFile %s\n", tbuf );
		return 404;
	}

	RegFD( h, RFD_open | RFD_openFD, ChPtr->idx );
	ChannelAttachFD( ChPtr, h );
	
	fstat( h, &statbuf );
	sz = statbuf.st_size;
	
	if (verbose&2) printf( "ReadFile %s as %s\n", tbuf, content_type );
	
	ChPtr->req_status = 200;

	bprintf( bptr, "HTTP/1.0 200 OK\n" );
	tv = time( NULL );
	strftime( tbuf, sizeof( tbuf ), "%a, %d %b %Y %T", gmtime( &tv ) );
	bprintf( bptr, "Date: %s GMT\n", tbuf );
	bprintf( bptr, "Server: \n", ServerSoftware );
	bprintf( bptr, "Content-type: %s\n", content_type );
	bprintf( bptr, "Content-length: %d\n", sz );
	tv = statbuf.st_mtime;
	strftime( tbuf, sizeof( tbuf ), "%a, %d %b %Y %T", gmtime( &tv ) );
	bprintf( bptr, "Last-modified: %s GMT\n", tbuf );
	bprintf( bptr, "\n" );
	
#if 0
	if (ChPtr->serve_type != ServeHEAD) {
		while (sz > 0) {
			if (ChPtr->wservptr->flags & WS_Thread) {
				if (BufferLength( bptr ) >= READFILE_BUFLIMIT) {
					SetRF( ChPtr, RF_Write, 0 );
					sched_yield();
					if (InSelect) SendKICK( "Read" );
				}
			}

			tsz = (sz>READFILE_MAX)?READFILE_MAX:sz;
			BufferEnqueue( bptr, NULL, tsz );
			p = _BufWritePtr( bptr );
			p -= tsz;
			if ((n = read( h, p, tsz )) > 0) {
				p += n;
				sz -= n;
				if (n != tsz) bptr->write - tsz + n;
			}
		}
	}
#else
	if (ChPtr->serve_type != ServeHEAD) {
		BufferEnqueue( bptr, NULL, sz );
		p = _BufWritePtr( bptr );
		p -= sz;
		while ((n = read( h, p, (sz>READFILE_MAX)?READFILE_MAX:sz )) > 0) {
			p += n;
			sz -= n;
			if (BufferLength( bptr ) >= 1024) SetRF( ChPtr, RF_Write, 0 );
		}
	}
#endif
	
	RFDclose( h );
	ChannelRemoveFD( ChPtr, h );
	ChPtr->req_status = 200;
	SetRF( ChPtr, RF_Write, RF_Execute );
	return 0;
}

