static char *Copyright=
"----------------------------------------------------------------------------\n"
"    woddity v%d.%02d%s - WebOddity, Web Server                              \n"
"    Copyright (C) 2001 - Robin Burgener, robinb@20q.net                     \n"
"                                                                            \n"
"    This program is free software; you can redistribute it and/or modify    \n"
"    it under the terms of the GNU General Public License as published by    \n"
"    the Free Software Foundation; either version 2 of the License, or       \n"
"    (at your option) any later version.                                     \n"
"                                                                            \n"
"    This program is distributed in the hope that it will be useful,         \n"
"    but WITHOUT ANY WARRANTY; without even the implied warranty of          \n"
"    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           \n"
"    GNU General Public License for more details.                            \n"
"                                                                            \n"
"    You should have received a copy of the GNU General Public License       \n"
"    along with this program; if not, write to the Free Software             \n"
"    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               \n"
"                                                                            \n"
"----------------------------------------------------------------------------\n";

#ifdef __USAGE
%C - WebOddity, Web Server
%C [options]

type "%C -h" for complete usage

#endif

char *Usage = 
"%s v%d.%2d%s - WebOddity, Web Server\n"
"%s [options]\n"
"\n"
"Options:\n"
"	-f ...	Config file\n"
"	-c ...	Config line\n"
"	-V      Verbose mode, the more the verboser (ie -VVV) \n"
"	-C	Display copyright, then exit\n"
"	-v	Print version number, then exit\n"
"	-h	Display help, then exit\n"
"\n"
"* See \"man woddity\" for more information\n";


#define	WEXT
#include "woddity.h"

void Wodd_BPCopyright( Buffer_t *bptr ) {
	bprintf( bptr, Copyright, WODD_VER_MAJ, WODD_VER_MIN, WODD_VER_REV );
}

int WoddityMain( int argc, char *argv[], char *envp[] ){
	int opt;
	char *s;

	WoddProgName = argv[0];
	
	if (s = strrchr( WoddProgName, '/' )) WoddProgName = s+1;
	
	verbose=1;
	
	while ((opt = getopt( argc, argv, "f:c:VCvHh?-" )) != -1 ) {
		switch (opt) {
			case '-':	break;
			case 'f':	ConfigWoddity( optarg );	break;
			case 'c':	LConfWoddity( NULL, optarg );		break;
			case 'V':	verbose = (verbose << 1) | 1;	break;
			case 'C':	
				printf( Copyright, WODD_VER_MAJ, WODD_VER_MIN, WODD_VER_REV );		
				exit( 0 );
			case 'v':	
				printf( "%d.%02d%s", WODD_VER_MAJ, WODD_VER_MIN, WODD_VER_REV );	
				exit( 0 );
			case 'H':
			case 'h':
			case '?':	
				printf( Usage, WoddProgName, WODD_VER_MAJ, WODD_VER_MIN, WODD_VER_REV, WoddProgName );
				exit( 0 );
		}
	}

	if (verbose) printf( Copyright, WODD_VER_MAJ, WODD_VER_MIN, WODD_VER_REV );		
	return RunWoddity( 0 );
}



