/*--------------------------------------------------------------------------
    woddity - WebOddity, Web Server                              
    Copyright (C) 2001 - Robin Burgener, robinb@20q.net                     
                                                                            
    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by    
    the Free Software Foundation; either version 2 of the License, or       
    (at your option) any later version.                                     
                                                                            
    This program is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           
    GNU General Public License for more details.                            
                                                                            
    You should have received a copy of the GNU General Public License       
    along with this program; if not, write to the Free Software             
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               
                                                                            
--------------------------------------------------------------------------*/

#include "woddity.h"

static FILE *logfp=NULL;
static int	log_counter=0;
static FILE *elogfp=NULL;
static int	elog_counter=0;

int log_req_status( Channel_t *ChPtr ) {
	VServer_t	*VSPtr, *qVSPtr;
	char *s, *t, *q;
	int	i, retry;
	
	if (!ChPtr) {
//		if (logfp) fclose( logfp );
//		logfp = NULL;
		return 0;
	}

	s = tprintf( "%s %d %d\n", ChPtr->req_log, ChPtr->req_status, ChPtr->total_write );

	if ((VSPtr = ChPtr->VSPtr) == NULL) {
		if (verbose) printf( "*** No LOG file - REQ: %s", s );
		return 0;
	}
	if (VSPtr->log_slave) VSPtr = VSPtr->log_slave;
	
	if (VSPtr->logfp == NULL) {
		if ((VSPtr->LOGName == NULL) || (*(VSPtr->LOGName) != '/')) {
			if (*(VSPtr->LOGRoot) != '/') VSPtr->LOGRoot = dupprintf( "/%s", VSPtr->LOGRoot );
			if (*(t = VSPtr->LOGRoot + strlen( VSPtr->LOGRoot ) - 1) == '/') *t=0;

			if (VSPtr->LOGName) t = tprintf( "%s/%s", VSPtr->LOGRoot, VSPtr->LOGName );
			else t = tprintf( "%s/%s", VSPtr->LOGRoot, VSPtr->ServerName );

			VSPtr->LOGName = strperm( t );
			
		}
		if (ChPtr->VSPtr->log_slave == NULL) {
			for (i=0; i<MAX_VSERVER; i++) {
				if ((qVSPtr = VServers[i]) == NULL) break;
				if (qVSPtr == VSPtr) break;
				if (qVSPtr->log_slave) continue;
				if (qVSPtr->LOGName == NULL) continue;
				if (strcmp( qVSPtr->LOGName, VSPtr->LOGName ) != 0) continue;
				VSPtr = VSPtr->log_slave = qVSPtr;
			}
		}
	}
	if (VSPtr->logfp == NULL) {
		for (retry=0; retry < 3; retry++) {
			if (VSPtr->logfp = fopen( VSPtr->LOGName, "a" )) break;
			q = tprintf( "%s", VSPtr->LOGName );
			if (t = strrchr( s, '/' )) *t=0;
			mkdir( q, 0755 );
		}

		if (VSPtr->logfp) RegFD( fileno( VSPtr->logfp), RFD_open | RFD_openFILE, 0 );
		VSPtr->log_counter=10000;
	}	
	if (VSPtr->logfp != NULL) {
		fwrite( s, strlen( s ), 1, VSPtr->logfp );
		fflush( VSPtr->logfp );
	}
#if 0
	if (VSPtr->logfp && (--(VSPtr->log_counter) <= 0)) {
		RegFD( fileno( VSPtr->logfp), RFD_close, 0 );
		fclose( VSPtr->logfp );
	}
#endif
	strncpy( req_log_buffer[req_log_head], s, 255 );
	if (++req_log_head >=req_log_max) req_log_head = 0;
	
	if (verbose&4) printf( "REQ: %s", s );
	return 0;
}

int log_error( Channel_t *ChPtr, char *msg ) {
	char *s;

	if (!ChPtr && !msg) {
		if (elogfp) fclose( elogfp );
		elogfp = NULL;
		return 0;
	}
	
	if (ChPtr && ChPtr->SPtr) ChPtr = ChPtr->SPtr;

	s = msg + strlen( msg ) -1;
	while ((s > msg) && isspace( *s )) *s-- = 0;
			
	if (ChPtr) {
		s = tprintf( "%s %d %d %d \tmsg: %s\n", ChPtr->req_log, ChPtr->req_status, ChPtr->total_write, ChPtr->total_time, msg );
	} else {
		s = tprintf( "*** INTERNAL \tmsg: %s (%d)\n", msg );
	}

	if (elogfp == NULL) {
		elogfp = fopen( tprintf( "%s/error.log", LOGRoot ), "a" );
		RegFD( fileno( elogfp), RFD_open | RFD_openFILE, 0 );
		elog_counter=1000;
	}	
	if (elogfp != NULL) {
		fwrite( s, strlen( s ), 1, elogfp );
		fflush( elogfp );
	}
	if (elogfp && (--elog_counter <= 0)) {
		RegFD( fileno( elogfp), RFD_close, 0 );
		fclose( elogfp );
		elogfp = fopen( tprintf( "%s/error.log", LOGRoot ), "a" );
		elog_counter=1000;
	}

	strncpy( err_log_buffer[err_log_head], s, 255 );
	if (++err_log_head >=err_log_max) err_log_head = 0;

	if (verbose & 2) printf( "ERR: %s", s );
	return 0;
}


