/*--------------------------------------------------------------------------
    woddity - WebOddity, Web Server                              
    Copyright (C) 2001 - Robin Burgener, robinb@20q.net                     
                                                                            
    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by    
    the Free Software Foundation; either version 2 of the License, or       
    (at your option) any later version.                                     
                                                                            
    This program is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           
    GNU General Public License for more details.                            
                                                                            
    You should have received a copy of the GNU General Public License       
    along with this program; if not, write to the Free Software             
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               
                                                                            
--------------------------------------------------------------------------*/

#include "woddity.h"

VisitorTrack_t	*FindVisitorTrack( struct in_addr iaddr ) {
	int	i, ct, dt;
	VisitorTrack_t	*VTPtr;
	VisitorTrack_t	*OldVTPtr=NULL;
	int	OldAge=0;
	

	if (!VisitorTrack) {
		if ((VisitorTrack = calloc( MaxVisitorTrack, sizeof( VisitorTrack_t ) )) == NULL) return NULL;
		NumVisitorTrack=0;
	}
	ct = GetCurrentTime();
	
	for (VTPtr=VisitorTrack, i=0; i<=NumVisitorTrack; i++, VTPtr++) {
		if (VTPtr->iaddr.s_addr == iaddr.s_addr) return VTPtr;
		if (VTPtr->iaddr.s_addr == 0) {
			memset( VTPtr, 0, sizeof( VisitorTrack_t ) );
			if (i>=NumVisitorTrack) NumVisitorTrack=i+1;
			VTPtr->iaddr = iaddr;
			VTPtr->create_time = VTPtr->access_time = ct;
			return VTPtr;
		}
		dt = ct - VTPtr->access_time;
		if (dt < OldAge) continue;
		OldAge = dt;
		OldVTPtr = VTPtr;
	}
	return OldVTPtr;
}

int RegVisitorTrack( Channel_t *ChPtr, struct in_addr iaddr ) {
	VisitorTrack_t	*VTPtr;
	int	t, ct;
	
	if (verbose & 4) printf( "VisitorTracking %s\n", inet_ntoa( iaddr ) );
	if ((VTPtr = FindVisitorTrack( iaddr )) == NULL) return -1;
	ct = GetCurrentTime();

	if (VTPtr->total_req) {
		t = ct - VTPtr->access_time;
		if (t < WTHour) AddMetric( &(VTPtr->TperREQ), t );
	}
	VTPtr->access_time = ct;
	VTPtr->total_req++;
	ChPtr->VTPtr = VTPtr;
	return 0;
}
